
(* Def. du Spol(p,q)                                    *)
(* Def de G1 (se reduit vers 0), G2 (les Spol(fi,fj) se *)
(* reduisent vers 0)                                    *)
(* G3_CR (en fait : reduction est confluente)           *)
(* G3 : forme normale unique                            *)
(* G1 => G2                     *)
(* G3_CR => G3                  *)
(* G3_CR =>  vrai CR            *)
(* f = g - m.fi et hterm(m.fi) n'est plus dans f, alors   *)
(*  g ->red  f  par fi                                          *)
(* du coup, f et f-m.fi on un successuer commun                 *)
(* Du coup equiv_Id2 => Red_equiv                               *)
(* et G3_CR  => G1                                              *)


Require Export normal_tes.

(* Cargamos prop_ord_pol IMPORTANTEEEEEEEEEEEEEEEEE *)

(*Split with (exist pol [x:pol](full_pol x) x H0).  Freire   *)


(* Seguimos con S_poly_nuevo2_tes.v *)

Definition S_pol :=
   [p,q:pol] Cases p q of
     vpol x   =>   vpol
  |  x vpol   =>   vpol
 | p q   =>
           (suma_app 
     (mult_m p  
            ((divQ unQ (hcoef p)),
             (div_term (lcm (hterm p) (hterm q)) (hterm p))))
     (pol_opp (mult_m q 
                      ((divQ unQ (hcoef q)),
                       (div_term (lcm (hterm p) (hterm q)) 
                                 (hterm q))))))
   end.

Lemma full_term_S_pol: (f,g:pol)(full_term_pol f)->(full_term_pol g)->
         (full_term_pol (S_pol f g)).

Induction f.
Intros.
Unfold S_pol.
Trivial.

Induction m.
Induction g.
Intros.
Unfold S_pol; Trivial.

Induction m0.
Intros.
Unfold S_pol.
Apply full_term_suma_app; Auto.
Apply full_term_opp; Auto.
Save.

Lemma S_pol_n_vpol: (p,q:pol)(~(equpol p vpol))->(~(equpol q vpol))->

(S_pol p q) = (suma_app 
     (mult_m p  
            ((divQ unQ (hcoef p)),
             (div_term (lcm (hterm p) (hterm q)) (hterm p))))
     (pol_opp (mult_m q 
                      ((divQ unQ (hcoef q)),
                       (div_term (lcm (hterm p) (hterm q)) 
                                 (hterm q)))))).
Induction p; Intros.
Elim H; Auto.

Induction q; Intros.
Elim H1; Auto.

Auto.
Save.
Hints Resolve S_pol_n_vpol.

Lemma S_pol_ext: (f,x,g,y:pol)(full_term_pol f)->
 (full_term_pol x)->(full_term_pol g)->(full_term_pol y)->
  ~(equpol f vpol)->~(equpol g vpol)->(equpol f x)->(equpol g y)->
     (equpol (S_pol f g) (S_pol x y)).

Intros.
Cut ~(equpol x vpol); Intros.
Cut ~(equpol y vpol); Intros.
Cut (S_pol f g)
     =(suma_app
        (mult_m f
          ((divQ unQ (hcoef f)),
           (div_term (lcm (hterm f) (hterm g)) (hterm f))))
        (pol_opp
          (mult_m g
            ((divQ unQ (hcoef g)),
             (div_term (lcm (hterm f) (hterm g)) (hterm g)))))); Intros.
Cut (S_pol x y)
     =(suma_app
        (mult_m x
          ((divQ unQ (hcoef x)),
           (div_term (lcm (hterm x) (hterm y)) (hterm x))))
        (pol_opp
          (mult_m y
            ((divQ unQ (hcoef y)),
             (div_term (lcm (hterm x) (hterm y)) (hterm y)))))); Intros.
Rewrite H9.
Rewrite H10.
Clear H9.
Clear H10.
Apply equpol_ss.
Apply mult_pm_comp_ss; Trivial; Simpl.
Right.
Split.
Cut (hterm f)=(hterm x); Intros.
Cut (hterm g)=(hterm y); Intros.
Rewrite H9.
Rewrite H10; Trivial.

Apply eq_hterm; Trivial.

Apply eq_hterm; Trivial.

Apply eg_numeraQ; Auto.

Apply opp_comp.
Apply mult_pm_comp_ss; Trivial; Simpl.
Right.
Split.
Cut (hterm f)=(hterm x); Intros.
Cut (hterm g)=(hterm y); Intros.
Rewrite H9.
Rewrite H10; Trivial.

Apply eq_hterm; Trivial.

Apply eq_hterm; Trivial.

Apply eg_numeraQ; Auto.

Apply S_pol_n_vpol; Auto.

Apply S_pol_n_vpol; Auto.

EAuto.

EAuto.
Save.

Lemma S_pol_ff: (f:pol)(equpol (S_pol f f) vpol).
Induction f.
Auto.

Intros.
(Unfold S_pol; Auto).
Save.
Hints Resolve S_pol_ff.

Lemma S_pol_sym: (f,g:pol)(equpol (S_pol f g) (pol_opp (S_pol g f))).
Induction f.
(Induction g; Auto).

Induction g.
Auto.

Intros.
Unfold S_pol.
Apply equpol_tran
 with (suma_app
        (pol_opp
          (mult_m (cpol m0 p0)
            ((divQ unQ (hcoef (cpol m0 p0))),
             (div_term (lcm (hterm (cpol m p)) (hterm (cpol m0 p0)))
               (hterm (cpol m0 p0))))))
        (mult_m (cpol m p)
          ((divQ unQ (hcoef (cpol m p))),
           (div_term (lcm (hterm (cpol m p)) (hterm (cpol m0 p0)))
             (hterm (cpol m p)))))).
Auto.

Apply equpol_tran
 with (suma_app
        (pol_opp
          (mult_m (cpol m0 p0)
            ((divQ unQ (hcoef (cpol m0 p0))),
             (div_term (lcm (hterm (cpol m0 p0)) (hterm (cpol m p)))
               (hterm (cpol m0 p0))))))
        (mult_m (cpol m p)
          ((divQ unQ (hcoef (cpol m p))),
           (div_term (lcm (hterm (cpol m0 p0)) (hterm (cpol m p)))
             (hterm (cpol m p)))))).
Apply equpol_ss.
Apply opp_comp.
Apply mult_pm_comp_2.
Simpl.
Right.
(Split; Auto).

Apply mult_pm_comp_2.
Simpl.
Right.
(Split; Auto).

Apply equpol_tran
 with (suma_app
        (mult_m (cpol m p)
          ((divQ unQ (hcoef (cpol m p))),
           (div_term (lcm (hterm (cpol m0 p0)) (hterm (cpol m p)))
             (hterm (cpol m p)))))
        (pol_opp
          (mult_m (cpol m0 p0)
            ((divQ unQ (hcoef (cpol m0 p0))),
             (div_term (lcm (hterm (cpol m0 p0)) (hterm (cpol m p)))
               (hterm (cpol m0 p0))))))); Auto.
Save.
Hints Resolve S_pol_sym.

(*
Definition Groebner1:= 
[F:(list pol)]
  ((full_fam F)/\
   (f:pol)(Ideal f F)->(Red3 F f vpol)). 
Hints Unfold  Groebner1.
*)

Definition Groebner1_full:= 
[F:(list pol_full)]
  ((full_fam (inc_list F))/\
   (f:pol_full)(Ideal (inc f) (inc_list F))->(Red3 (inc_list F) (inc f) vpol)). 
Hints Unfold  Groebner1_full.

(*
Definition Groebner2:= 
 [F:(list pol)]
  ((full_fam F)/\
   (f,g:pol)
   (pol_In_ensemb f F)->(pol_In_ensemb g F)->
                          (Red3 F (S_pol f g) vpol)).
Hints Unfold  Groebner2.
*)
 
 (* Quizas meter full_pol (S_pol f g) *)

Definition Groebner2_full:= 
 [F:(list pol_full)]
  ((full_fam (inc_list F))/\
   (f,g:pol_full)
(pol_In_ensemb (inc f) (inc_list F))->(pol_In_ensemb (inc g) (inc_list F))->
                (Red3 (inc_list F) (S_pol (inc f) (inc g)) vpol)).
Hints Unfold Groebner2_full. 

(* De momento lo eliminamos para pasar todo a pol_full
 
Lemma G1_impl_G2: (G:(list pol))(Groebner1 G)->(Groebner2 G).
Intros G.
Unfold Groebner1.
Intros.
Unfold Groebner2.
(Elim H; Intros).
(Split; Trivial).
Intros.
Apply H1.
Replace (S_pol f g)
 with (suma_app
        (mult_m f
          ((divQ unQ (hcoef f)),
           (div_term (lcm (hterm f) (hterm g)) (hterm f))))
        (pol_opp
          (mult_m g
            ((divQ unQ (hcoef g)),
             (div_term (lcm (hterm f) (hterm g)) (hterm g)))))).
Apply suma_p_id.
Apply pol_F_idmult.
Auto.

(Apply elem_full with G; Auto).

Simpl.
Apply term_div_full.
Apply lcm_full.
(Apply full_pol_In_hterm with G; Auto).

(Apply full_pol_In_hterm with G; Auto).

(Apply full_pol_In_hterm with G; Auto).

Apply opp_p_id.
(Apply pol_F_idmult; Trivial).
(Apply elem_full with G; Auto).

Simpl.
Apply term_div_full.
Apply lcm_full.
(Apply full_pol_In_hterm with G; Auto).

(Apply full_pol_In_hterm with G; Auto).

(Apply full_pol_In_hterm with G; Auto).

(Cut ~(equpol f vpol); Intros).
(Cut ~(equpol g vpol); Intros).
(Symmetry; Auto).

(Apply elem_n_vpol with G; Trivial).

(Apply elem_n_vpol with G; Trivial).
Save.
Hints Resolve G1_impl_G2.

Este lema siguiente ya est demostrado antes se llama
pol_eq_id_eg 

Lemma ideal_ext: (p:pol)(F:(list pol))(Ideal p F)->(p':pol)(equpol p p')->
   (full_term_pol p')->(Ideal p' F).

Intros p F.
Induction 1; Intros.
Apply ideal_vpol; Trivial.
Apply equpol_tran with p0; Auto.

Apply ideal_cpol with p' q'; Auto.
Apply equpol_tran with p0; Auto.
Save.
*)

Lemma G1_impl_G2_full: (G:(list pol_full))(Groebner1_full G)->
   (Groebner2_full G).

Intros G.
Unfold Groebner1_full; Intros.
Unfold Groebner2_full; Elim H; Intros.
Split; Trivial.
Clear H.
Induction f; Simpl.
Induction g; Simpl; Intros.
Cut (Ideal (S_pol x x0) (inc_list G)); Intros.
Elim (can_fun (S_pol x x0)); Intros.
Elim p1; Intros.
Clear p1.
Apply Red3_ext2 with x1; Intros; Auto.
Elim ex_fpol_eq with x1; Intros; Auto.
Apply Red3_ext2 with (inc x2); Auto.
Apply H1; Auto.
Apply pol_eq_id_eg with (S_pol x x0); Auto.
Apply equpol_tran with x1; Auto.

Apply full_term_S_pol; Auto.

Apply full_term_S_pol; Auto.

Replace (S_pol x x0) with (suma_app (mult_m x
   ((divQ unQ (hcoef x)),(div_term (lcm (hterm x) (hterm x0)) (hterm x))))
      (pol_opp (mult_m x0 ((divQ unQ (hcoef x0)),
         (div_term (lcm (hterm x) (hterm x0)) (hterm x0)))))).
Apply suma_p_id.
Apply pol_F_idmult; Auto.

Simpl.
Apply term_div_full; Auto.

Apply opp_p_id.
Apply pol_F_idmult; Trivial.
Apply elem_full with (inc_list G); Auto.

Simpl.
Apply term_div_full; Auto.

Cut ~(equpol x vpol); Intros.
Cut ~(equpol x0 vpol); Intros.
Symmetry; Auto.

Apply elem_n_vpol with (inc_list G); Trivial.

Apply elem_n_vpol with (inc_list G); Trivial.
Save.
Hints Resolve G1_impl_G2_full.

(*
Definition Groebner3:= [F:(list pol)]
      ((full_fam F)/\
         (h,h1,h2:pol)
          (normal F h1)->(normal F h2)->
            (Red3 F h h1)->(Red3 F h h2)->       
                  (equpol h1 h2)).
Hints Unfold  Groebner3.
*)

Definition Groebner3_full:= [F:(list pol_full)]
      ((full_fam (inc_list F))/\
         (h,h1,h2:pol_full)
          (normal (inc_list F) (inc h1))->(normal (inc_list F) (inc h2))->
            (Red3 (inc_list F) (inc h) (inc h1))->
               (Red3 (inc_list F) (inc h) (inc h2))->(equpol (inc h1) (inc h2))).
Hints Unfold  Groebner3_full.

Definition confluente :=
   [F:(list pol)][f:pol](g:pol)(h:pol)(Red3 F f g)->(Red3 F f h)->(common_succ F g h).
Hints Unfold confluente.

Inductive common_succ_full [F:(list pol_full);g,h:pol_full]: Prop:=
           common_succ_red_full: (p:pol_full)(Red3 (inc_list F) (inc g) (inc p))->(Red3 (inc_list F) (inc h) (inc p))->(common_succ_full F g h).
Hints Resolve common_succ_red_full.

Lemma comp_common_succ_full: (p,q,r,s:pol_full)(F:(list pol_full))
   (equpol (inc p) (inc q))->(equpol (inc r) (inc s))->
      (common_succ_full F p r)->(common_succ_full F q s).

Intros p q r s F e1 e2.
Induction 1; Intros.
Split with p0.
Apply Red3_ext2 with f:=(inc p); Auto.

Apply Red3_ext2 with f:=(inc r); Auto.
Save.

Lemma trans_common_red_full:(f,g,h:pol_full)(F:(list pol_full))
 (Red1 (inc_list F) (inc h) (inc f))->(common_succ_full F g f)->
    (common_succ_full F g h).
Intros.
Inversion H0.
Apply common_succ_red_full with p; Trivial.
Apply Red3_tran with (inc f); Trivial.
Apply Red3_ste; Trivial.
Save.  
Hints Resolve trans_common_red_full.

Lemma conmt_common_succ_full: (p,q:pol_full)(F:(list pol_full))
   (common_succ_full F p q)->(common_succ_full F q p).
Induction 1.
Intros.
Exists p0; Assumption.
Save.
Hints Resolve conmt_common_succ_full.

Definition confluente_full :=
   [F:(list pol_full)][f:pol_full](g:pol_full)(h:pol_full)
      (Red3 (inc_list F) (inc f) (inc g))->
         (Red3 (inc_list F) (inc f) (inc h))->
            (common_succ_full F g h).
Hints Unfold confluente_full.

(* ========================================== Cambio *)

(*
Definition Groebner3_CR:= [F:(list pol)]
     ((full_fam F)/\(h:pol)(confluente F h)).        
Hints Unfold  Groebner3_CR.
*)

Definition Groebner3_CR_full:= [F:(list pol_full)]
     ((full_fam (inc_list F))/\(h:pol_full)(confluente_full F h)).        
Hints Unfold  Groebner3_CR_full.

(* de momento la olvidamos para utilizar pol_full
 
Lemma G3_CR_impl_G3: (G:(list pol))
       (Groebner3_CR G)->(Groebner3 G).
Unfold Groebner3_CR Groebner3.
(Intros G; Destruct 1; Intros fG cr; Split).
Assumption.
 
Intros h h1 h2 nh1 nh2 r01 r02.
(Elim (cr h h1 h2); Trivial).
(Intros x r1 r2; Apply equpol_tran with x).
(Apply normal_eq with G; Auto).
 
(Apply equpol_sym; Apply normal_eq with G; Auto).
Save.
Hints Resolve G3_CR_impl_G3.
*)

Lemma G3_CR_impl_G3_full: (G:(list pol_full))(Groebner3_CR_full G)->
                             (Groebner3_full G).

Unfold Groebner3_CR_full Groebner3_full.
Intros G; Destruct 1; Intros fG cr; Split.
Assumption.

Intros h h1 h2 nh1 nh2 r01 r02.
Elim (cr h h1 h2); Trivial.
Intros x r1 r2.
Apply equpol_tran with (inc x).
Apply normal_eq with (inc_list G); Auto.

Apply equpol_sym; Apply normal_eq with (inc_list G); Auto.
Save.

(* De momento lo dejamos para pasar a pol_full

Lemma cr: (G:(list pol))(h1,h2:pol)
  (Groebner3_CR G)->
   (Red_equiv G h1 h2)->
      (Ex2 [g:pol](Red3 G h1 g) [g:pol](Red3 G h2 g)).
(Intros G h1 h2; Destruct 1; 
    Intros fG G3G Reh1h2; Elim Reh1h2).
Intros g; Intros; Split with g; Auto.
 
Intros g h; Split with h; Auto.
 
Intros g h f1G fg fh Regh; Destruct 1; Intros g0 Hg0; 
   Split with g0.
Auto.
 
Auto.
 
Intros g f h fGG fg ff fh Regf.
Destruct 1; Intros g0 Hg0 H1g0 Regff; Destruct 1; 
    Intros g1 h1g1 h2g1.
Elim (G3G f g0 g1); Auto.
Intros g2 h1g2 h2g2; Split with g2; Auto.
Apply Red3_tran with g0; Auto.
 
Apply Red3_tran with g1; Auto.
Save.
Hints Resolve cr.
*)

Lemma cr_full: (G:(list pol_full))(h1,h2:pol_full)
   (Groebner3_CR_full G)->(Red_equiv (inc_list G) (inc h1) (inc h2))->
      (Ex2 [g:pol_full](Red3 (inc_list G) (inc h1) (inc g)) 
           [g:pol_full](Red3 (inc_list G) (inc h2) (inc g))).

Intros G h1 h2.
Destruct 1.
Intros fG G3G Reh1h2.
Elim Reh1h2.
Intros.
Elim (can_fun g); Intros; Trivial.
Elim p; Intros; Clear p.
Split with (exist pol [p:pol](full_pol p) x H4); Simpl; Auto.

Apply Red3_trans with g; Auto.

Intros.
Elim (can_fun h); Intros; Trivial.
Elim p; Intros; Clear p.
Split with (exist pol [p:pol](full_pol p) x H4); Simpl; Auto.
Apply Red3_ext1 with h; Auto.

Intros g h.
Intros f1G fg fh Regh.
Destruct 1.
Intros g0 Hg0.
Intros.
Split with g0; Auto.

Intros g f h fGG fg ff fh Regf.
Destruct 1.
Intros g0 Hg0 H1g0 Regff.
Destruct 1.
Intros g1 h1g1 h2g1.
Elim (can_fun f); Intros; Trivial.
Elim p; Intros; Clear p.
Elim (G3G (exist pol [p:pol](full_pol p) x H2) g0 g1); Auto.
Intros g2 h1g2 h2g2.
Split with g2; Auto.
Apply Red3_tran with (inc g0); Auto.

Apply Red3_tran with (inc g1); Auto.

Simpl.
Apply Red3_ext2 with f; Auto.

Simpl.
Apply Red3_ext2 with f; Auto.
Save.

(* Pasado a reduccio2_tes.v
Lemma sufc_Red1: 
 (f,g,fi:pol)(F:(list pol))(full_fam F)->
   (full_term_pol g)->(full_term_pol f)->
   (pol_In_ensemb fi F)->
     (m:monom)(full_mon n m)->~(z_monom m)->
      (equpol f (suma_app g (pol_opp (mult_m fi m))))->
        (no_term_in_pol f (hterm (mult_m fi m)))->
              (Red1 F g f).
Induction m; Intros.
Red in H6.
Split with fi; Auto.
Apply red1_simpl with t:=(hterm (mult_m fi (y,y0))); Trivial.
Red.
Cut ~(eqQ
       (coef (pol_opp (mult_m fi (y,y0))) (hterm (mult_m fi (y,y0))))
       OQ).
Intros.
Cut (eqQ (coef f (hterm (mult_m fi (y,y0))))
      (plusQ (coef g (hterm (mult_m fi (y,y0))))
        (coef (pol_opp (mult_m fi (y,y0))) (hterm (mult_m fi (y,y0)))))).
Intros.
Cut (eqQ OQ
      (plusQ (coef g (hterm (mult_m fi (y,y0))))
        (coef (pol_opp (mult_m fi (y,y0))) (hterm (mult_m fi (y,y0)))))).
Intros.
Cut (eqQ (coef g (hterm (mult_m fi (y,y0))))
      (multQ_neg
        (coef (pol_opp (mult_m fi (y,y0))) (hterm (mult_m fi (y,y0))))));
Auto.
Intros.
Apply comp_nOQ
 with c:=(multQ_neg
           (coef (pol_opp (mult_m fi (y,y0)))
             (hterm (mult_m fi (y,y0))))); Auto.
 
(Apply eqQ_trans with (coef f (hterm (mult_m fi (y,y0)))); Auto).

Apply eqQ_trans
 with (coef (suma_app g (pol_opp (mult_m fi (y,y0))))
        (hterm (mult_m fi (y,y0)))).
(Apply eqQ_trans
  with (coef (suma_app g (pol_opp (mult_m fi (y,y0))))
         (hterm (mult_m fi (y,y0)))); Auto).

Auto.

Apply comp_nOQ
 with c:=(multQ_neg
           (coef (mult_m fi (y,y0)) (hterm (mult_m fi (y,y0))))); 
Auto.
Apply multQ_n_OQ.
Cut (term_in_pol (mult_m fi (y,y0)) (hterm (mult_m fi (y,y0)))).
Intros.
(Red in H7; Auto).
 
Apply occ_n_vpol.
(Apply contr_mult_nz_monom; Auto).
(Apply elem_full with F; Auto).
 
(Apply elem_n_vpol with F; Auto).
 
(Apply full_mult_m; Auto).
(Apply elem_full with F; Auto).
 
(Apply elem_full with F; Auto).
 
(Apply elem_n_vpol with F; Auto).
 
Replace (hterm (mult_m fi (y,y0)))
 with (term_mult (hterm fi) (mon_term (y,y0))).
Simpl.
Replace (term_mult (hterm fi) y0) with (term_mult y0 (hterm fi)); Auto.
 
Symmetry.
Apply hterm_mult_m; Auto.
(Apply elem_full with F; Auto).
 
(Apply elem_n_vpol with F; Auto).

Apply equpol_tran with (suma_app g (pol_opp (mult_m fi (y,y0))));
Trivial.
Apply equpol_ss; Trivial.
Apply opp_comp.
Apply mult_pm_comp_2.
Simpl.
Unfold z_monom in H3.
Right .
Split.
Replace (hterm (mult_m fi (y,y0)))
 with (term_mult (hterm fi) (mon_term (y,y0))).
Simpl.
Transitivity (term_mult (div_term (hterm fi) (hterm fi)) y0).
Transitivity (term_mult y0 (div_term (hterm fi) (hterm fi))); Auto.
Replace (div_term (hterm fi) (hterm fi)) with (n_term_O n).
Symmetry.
Apply term_mult_full_nulo.
(Inversion H3; Auto).
 
Symmetry.
Apply term_div_eq.
EAuto.
 
(Apply mult_div_term1 with n:=n; Trivial).
EAuto.
 
EAuto.
 
Simpl.
Symmetry.
Transitivity (term_mult (hterm fi) (mon_term (y,y0))); Auto.
Apply hterm_mult_m; Auto.
(Apply elem_full with F; Auto).

(Apply elem_n_vpol with F; Auto).
 
Apply eqQ_trans
 with (divQ (coef (mult_m fi (y,y0)) (hterm (mult_m fi (y,y0))))
        (hcoef fi)).
Apply eqQ_trans with (divQ (hcoef (mult_m fi (y,y0))) (hcoef fi)).
Apply eqQ_trans
 with (divQ (multQ (hcoef fi) (mon_coef (y,y0))) (hcoef fi)).
Simpl.
Apply eqQ_sym.
Apply simpl_divQ.
Apply cond_ht_pol.
(Apply elem_full with F; Auto).
 
(Apply elem_n_vpol with F; Auto).
 
Apply eg_denomQ.
Apply cond_ht_pol.
(Apply elem_full with F; Auto).
 
(Apply elem_n_vpol with F; Auto).
 
Apply eqQ_sym.
(Apply hcoef_mult; Trivial).
(Apply elem_full with F; Auto).
 
(Apply elem_n_vpol with F; Auto).
 
Apply eg_denomQ.
Apply cond_ht_pol.
(Apply elem_full with F; Auto).
 
(Apply elem_n_vpol with F; Auto).
 
Apply coef_hterm.
Apply full_mult_m.
(Inversion H3; Auto).

(Apply elem_full with F; Auto).
 
Apply eg_denomQ.
Apply cond_ht_pol.
(Apply elem_full with F; Auto).
 
(Apply elem_n_vpol with F; Auto).
 
Cut (equpol (suma_app f (mult_m fi (y,y0))) g).
Intros.
Apply eqQ_trans
 with (plusQ (coef f (hterm (mult_m fi (y,y0))))
        (coef (mult_m fi (y,y0)) (hterm (mult_m fi (y,y0))))).
Apply eqQ_trans
 with (plusQ OQ (coef (mult_m fi (y,y0)) (hterm (mult_m fi (y,y0)))));
Auto.
Apply eqQ_trans
 with (plusQ (coef (mult_m fi (y,y0)) (hterm (mult_m fi (y,y0)))) OQ);
Auto.
 
(Apply eqQ_trans
  with (coef (suma_app f (mult_m fi (y,y0))) (hterm (mult_m fi (y,y0))));
 Auto).
 
Auto.
Save.
Hints Resolve sufc_Red1.
*)

(* Pasado a Axiomas_n_full2_tes.v

Lemma minuto3: (f,g,fi:pol)(F:(list pol))(full_fam F)->(full_term_pol f)->
   (full_term_pol g)->(pol_In_ensemb fi F)->(m:monom)(full_mon n m)->
      ~(z_monom m)->(equpol f (suma_app g (pol_opp (mult_m fi m))))->
         (common_succ F f g).
Induction m; Intros.
Elim (dec_term_in_pol f (hterm (mult_m fi (y,y0)))).
Intros.
Red in y1.
Elim (decQ (coef g (hterm (mult_m fi (y,y0))))).
Intros.
Cut (eqQ (coef f (hterm (mult_m fi (y,y0))))
      (multQ_neg (coef (mult_m fi (y,y0)) (hterm (mult_m fi (y,y0)))))).
Intros.
Cut (equpol g (suma_app f (mult_m fi (y,y0)))); Auto.
Intros.
Clear H5.
Cut (Red1 F f g); Auto.
Apply sufc_Red1 with fi:=fi m:=(monom_op (y,y0)); Trivial.
Unfold monom_op.
Unfold z_monom.
Simpl.
Simpl in H4.
Auto.
 
Apply equpol_tran with (suma_app f (mult_m fi (y,y0))); Auto.
 
Red.
Apply eqQ_trans with (coef g (hterm (mult_m fi (y,y0)))); Auto.
(Replace (hterm (mult_m fi (monom_op (y,y0))))
  with (hterm (mult_m fi (y,y0))); Auto).
(Apply hterm_pol_m_opp; Auto).
(Apply elem_full with F; Auto).
 
(Apply elem_n_vpol with F; Auto).

Apply eqQ_trans
 with (plusQ (coef g (hterm (mult_m fi (y,y0))))
        (coef (pol_opp (mult_m fi (y,y0))) (hterm (mult_m fi (y,y0))))).
Apply eqQ_trans with (coef (suma_app g (pol_opp (mult_m fi (y,y0)))) (hterm (mult_m fi (y,y0)))); Auto.
 
Apply eqQ_trans
 with (plusQ OQ
        (multQ_neg (coef (mult_m fi (y,y0)) (hterm (mult_m fi (y,y0)))))).
Auto.
 
Apply eqQ_trans
 with (plusQ
        (multQ_neg (coef (mult_m fi (y,y0)) (hterm (mult_m fi (y,y0)))))
        OQ); Auto.

Intros.
Cut (Red1 F f
      (suma_app g
        (pol_opp
          (mult_m fi
            ((divQ (coef g (hterm (mult_m fi (y,y0)))) (hcoef fi)),
             (mon_term (y,y0))))))).
Intros.
Cut (Red1 F g
      (suma_app g
        (pol_opp
          (mult_m fi
            ((divQ (coef g (hterm (mult_m fi (y,y0)))) (hcoef fi)),
             (mon_term (y,y0))))))).
Intros.
Split
 with (suma_app g
        (pol_opp
          (mult_m fi
            ((divQ (coef g (hterm (mult_m fi (y,y0)))) (hcoef fi)),
             (mon_term (y,y0)))))); Auto.
 
(Inversion H6; Auto).
Apply Red1_simp with f:=fi; Auto.
(Inversion H6; Auto).
(Apply red1_simpl with t:=(hterm (mult_m fi (y,y0))); Trivial).
(Apply elem_full with F; Auto).

Inversion H6.
(Apply full_term_suma_app; Trivial).
(Apply full_term_opp; Trivial).
(Apply full_mult_m; Auto).
(Apply elem_full with F; Auto).
 
(Apply elem_n_vpol with F; Auto).
 
Replace (hterm (mult_m fi (y,y0)))
 with (term_mult (hterm fi) (mon_term (y,y0))).
Simpl.
Replace (term_mult (hterm fi) y0) with (term_mult y0 (hterm fi)); Auto.
 
Symmetry.
Apply hterm_mult_m; Auto.
(Apply elem_full with F; Auto).
 
(Apply elem_n_vpol with F; Auto).
 
(Apply equpol_ss; Trivial).
Apply opp_comp.
Apply mult_pm_comp_2.
Simpl.
Right .
Split; Auto.
Replace (hterm (mult_m fi (y,y0)))
 with (term_mult (hterm fi) (mon_term (y,y0))).
Simpl.
Replace (div_term (term_mult (hterm fi) y0) (hterm fi))
 with (term_mult (div_term (hterm fi) (hterm fi)) y0).
Replace (div_term (hterm fi) (hterm fi)) with (n_term_O n).
Symmetry.
Replace (term_mult (n_term_O n) y0) with (term_mult y0 (n_term_O n));
Auto.

Symmetry.
Apply term_div_eq.
Apply full_hterm_full_pol.
(Apply elem_full with F; Auto).
 
(Apply mult_div_term1 with n:=n; Trivial).
Apply full_hterm_full_pol.
Apply elem_full with F; Auto.
 
Apply full_hterm_full_pol.
Apply elem_full with F; Auto.
 
Symmetry.
(Apply hterm_mult_m; Trivial).
(Apply elem_full with F; Auto).
 
(Apply elem_n_vpol with F; Auto).
 
(Apply Red1_simp with f:=fi; Auto).
Apply red1_simpl with t:=(hterm (mult_m fi (y,y0))).
Auto.
 
Assumption.
 
(Apply elem_full with F; Auto).
 
(Apply full_term_suma_app; Trivial).
Apply full_term_opp.
(Apply full_mult_m; Auto).
(Apply elem_full with F; Auto).
 
(Apply elem_n_vpol with F; Auto).
 
(Apply term_div_hterm; Trivial).
Apply elem_full with F; Auto.
 
Apply elem_n_vpol with F; Auto.

Apply equpol_tran
 with (suma_app (suma_app g (pol_opp (mult_m fi (y,y0))))
        (pol_opp
          (mult_m fi
            ((divQ (coef f (hterm (mult_m fi (y,y0)))) (hcoef fi)),
             (div_term (hterm (mult_m fi (y,y0))) (hterm fi)))))).
Apply equpol_tran
 with (suma_app g
        (suma_app (pol_opp (mult_m fi (y,y0)))
          (pol_opp
            (mult_m fi
              ((divQ (coef f (hterm (mult_m fi (y,y0)))) (hcoef fi)),
               (div_term (hterm (mult_m fi (y,y0))) (hterm fi))))))).
(Apply equpol_ss; Trivial).
Apply equpol_tran
 with (pol_opp
        (suma_app
          (mult_m fi
            ((divQ (coef f (hterm (mult_m fi (y,y0)))) (hcoef fi)),
             (div_term (hterm (mult_m fi (y,y0))) (hterm fi))))
          (pol_opp (pol_opp (mult_m fi (y,y0)))))).
Apply opp_comp.
Apply equpol_tran
 with (suma_app
        (mult_m fi
          ((divQ (coef f (hterm (mult_m fi (y,y0)))) (hcoef fi)),
           (div_term (hterm (mult_m fi (y,y0))) (hterm fi))))
        (mult_m fi (y,y0))).
Simpl.
Replace (div_term (hterm (mult_m fi (y,y0))) (hterm fi)) with y0.
Apply equpol_tran
 with (mult_m fi
        ((plusQ (divQ (coef f (hterm (mult_m fi (y,y0)))) (hcoef fi)) y),
         y0)).
Apply mult_pm_comp_2.
Simpl.
Right .
(Split; Trivial).
Apply eqQ_trans
 with (divQ
        (plusQ (coef f (hterm (mult_m fi (y,y0)))) (multQ y (hcoef fi)))
        (hcoef fi)).
Apply eg_denomQ.
Apply cond_ht_pol.
Apply elem_full with F; Auto.

Apply elem_n_vpol with F; Auto.
 
(Cut (equpol g (suma_app f (mult_m fi (y,y0)))); Auto).
Intros.
Apply eqQ_trans
 with (plusQ (coef f (hterm (mult_m fi (y,y0))))
        (coef (mult_m fi (y,y0)) (hterm (mult_m fi (y,y0))))).
Apply eqQ_trans
 with (coef (suma_app f (mult_m fi (y,y0))) (hterm (mult_m fi (y,y0))));
Auto.
 
Apply plusQ_comp; Auto.
Apply eqQ_trans with (hcoef (mult_m fi (y,y0))).
Apply eqQ_sym.
Apply coef_hterm.
(Apply full_mult_m; Auto).
(Apply elem_full with F; Auto).
 
Apply eqQ_trans with (multQ (hcoef fi) y); Auto.
Apply eqQ_trans with (multQ (hcoef fi) (mon_coef (y,y0))); Auto.
Apply hcoef_mult; Auto.
(Apply elem_full with F; Auto).
 
(Apply elem_n_vpol with F; Auto).

Apply eqQ_sym.
(Apply eqQ_trans
  with (plusQ y (divQ (coef f (hterm (mult_m fi (y,y0)))) (hcoef fi)));
 Auto).
Apply eqQ_trans
 with (divQ
        (plusQ (multQ y (hcoef fi)) (coef f (hterm (mult_m fi (y,y0)))))
        (hcoef fi)).
Apply plusQ_frac; Auto.
Apply cond_ht_pol.
(Apply elem_full with F; Auto).
 
(Apply elem_n_vpol with F; Auto).
 
Apply eg_denomQ; Auto.
Apply cond_ht_pol.
Apply elem_full with F; Auto.
 
Apply elem_n_vpol with F; Auto.
 
Auto.
 
Symmetry.
Replace (hterm (mult_m fi (y,y0)))
 with (term_mult (hterm fi) (mon_term (y,y0))).
Simpl.
Apply div_mult_mon_inv with n; Auto.
Apply full_hterm_full_pol.
(Apply elem_full with F; Auto).

Symmetry.
Apply hterm_mult_m; Auto.
(Apply elem_full with F; Auto).
 
(Apply elem_n_vpol with F; Auto).
 
Auto.
 
Auto.
 
Auto.
 
Auto.
 
Intros.
(Cut (Red1 F g f); Intros).
(Split with f; Auto).
 
(Apply sufc_Red1 with fi:=fi m:=(y,y0); Auto).
Save.
Hints Resolve minuto3.






Lemma minuto4: (f,g,fi:pol)(F:(list pol))(full_fam F)->
 (full_term_pol f)->(full_term_pol g)->(pol_In_ensemb fi F)->
  (m:monom)(full_mon n m)->
  (equpol f (suma_app g (pol_opp (mult_m fi m))))->
     (common_succ F f g).
(Induction m; Intros).
Elim (z_monom_dec (y,y0)).
Intros.
Cut (equpol f g).
Intros.
(Split with f; Auto).
 
Apply equpol_tran with (suma_app g (pol_opp (mult_m fi (y,y0)))).
Auto.

Apply equpol_tran with (suma_app g vpol).
(Apply equpol_ss; Trivial).
(Apply equpol_tran with (pol_opp vpol); Auto).
 
Auto.
 
Intros.
Apply minuto3 with fi:=fi m:=(y,y0); Auto.
Save.
Hints Resolve minuto4.




Lemma congr_conv : (F:(list pol))(f,g:pol)
       (equiv_Id2 F f g)-> (Red_equiv F f g).
Induction 1.
Auto.
 
Intros.
(Apply Red_equiv_trans with g1; Trivial).
Apply common_is_Red_equiv.
(Apply minuto4 with fi:=fi m:=m; Trivial).
Apply equpol_sym.
Apply equpol_tran
 with (suma_app g1 (suma_app (mult_m fi m) (pol_opp (mult_m fi m)))).
Apply equpol_tran
 with (suma_app (suma_app g1 (mult_m fi m)) (pol_opp (mult_m fi m))).
(Apply monot_suma; Assumption).
 
Auto.
 
(Apply equpol_tran with (suma_app g1 vpol); Auto).
Save.
Hints Resolve congr_conv.


*)

(* De momento lo dejamos por pol_full

Lemma G3_CR_impl_G1: (G:(list pol))(Groebner3_CR G)->(Groebner1 G).
Unfold Groebner1.
Intros G G3CR.
Split.
Unfold Groebner3_CR in G3CR.
(Elim G3CR; Auto).

Intros.
Cut (equiv_Id G f vpol).
Intros.
Cut (Red_equiv G f vpol).
Intros.
(Elim cr with G f vpol; Intros; Auto).
(Apply Red3_ext1 with x; Auto).
Apply equpol_sym.
(Apply normal_eq with G; Auto).

Unfold Groebner3_CR in G3CR.
(Elim G3CR; Auto).

Apply equiv_Id_cons; Auto.
Inversion G3CR; Auto.

Inversion H; Auto.
Save.
Hints Resolve G3_CR_impl_G1.
*)

(* Pasado a congr_y_red2_tes.v

Lemma Red_equiv_ext: (G : (list pol))(g,h:pol)(Red_equiv G g h)->
   (g':pol)(equpol g g')->(full_term_pol g')->(Red_equiv G g' h).

Intros G g h.
Induction 1; Intros.
Apply Red_equiv_eq; Auto.
Apply equpol_tran with g0; Auto.

Apply Red_equiv_step; Auto.
Apply Red1_ext2 with g0; Auto.

Apply Red_equiv_trans with h0; Auto.

Apply Red_equiv_trans with f; Auto.
Save.
*)

Lemma G3_CR_impl_G1_full: (G:(list pol_full))(Groebner3_CR_full G)->
   (Groebner1_full G).

Intros G G3CR.
Split; Intros.
Unfold Groebner3_CR_full in G3CR.
Elim G3CR; Auto.

Cut (equiv_Id (inc_list G) (inc f) vpol); Intros.
Elim ex_fpol_eq with vpol; Auto; Intros.
Cut (Red_equiv (inc_list G) (inc f) vpol); Intros.
Elim cr_full with G f x; Intros; Auto.
Apply Red3_ext1 with (inc x0); Auto.
Apply equpol_tran with (inc x); Auto.
Apply equpol_sym.
Apply normal_eq with (inc_list G); Auto.
Apply normal_ext with vpol; Auto.

Inversion H1.
Apply Red_equiv_eq; Auto.
Apply equpol_tran with vpol; Auto.

Apply Red_equiv_step; Auto.
Apply Red1_ext1 with vpol; Auto.

Apply Red_equiv_sym; Auto.
Apply Red_equiv_ext with vpol; Auto.

Apply Red_equiv_sym; Auto.
Apply Red_equiv_ext with vpol; Auto.

Apply congr_conv.
Apply equiv_Id_equiv_Id2; Trivial.

Inversion G3CR; Auto.
Save.

(*
Vamos aqui el 8/1/04 ?????????IMPORTANTEEEEEEEEEEEEEEEE
*)
