(* equiv_id :  f = g + sigma pi.fi  (param. par les fi.)                *)
(* Red_equiv ; cloture d'equivalence de Red1 (doncRed3 aussi)           *)
(* Si f Red_equiv g, alors f-g est dans l'ideal.                        *)
(* Pareil pour equiv_Id.                                                *)
(* equiv_Id stable par egalite                                          *)
(* f-g == p   =>  f== p+g.                                              *)
(* etre equiv_id  a 0 reste vrai si on agrandit la base.                *)
(* Si dans l'ideal, alors equiv_id a 0    (necessite lemmes d'inv. sur  *)
(* les familles term_full.                                              *)
(* et vice-versa.                                                       *)
(* si f-g ds l'ideal, alors f equiv_id g                                *)
(* Red_equiv => equiv_id.                                               *)





Require Export reduccion2_tes.

Inductive equiv_Id [F:(list pol);f:pol]: pol->Prop :=
   equiv_Id_cons: (g:pol)(full_fam F)->(full_term_pol f)->
      (full_term_pol g)->(Ideal (suma_app f (pol_opp g)) F)
         ->(equiv_Id F f g).
Hints Resolve equiv_Id_cons.

Lemma equiv_id_trans :
 (F:(list pol))(f,g,h:pol)(equiv_Id F f g)->
             (equiv_Id F g h)->(equiv_Id F f h).

Induction 1.
Induction 5; Intros.
Apply equiv_Id_cons; Trivial.
Apply pol_eq_id_eg
 with (suma_app (suma_app f (pol_opp g0)) (suma_app g0 (pol_opp g1))).
Apply suma_p_id; Trivial.

Auto.

Auto.
Save.

(* Funciona pero no lo necesitamos

Lemma id_equiv1_congr:  (f,g,fi:pol)(F:(list pol))(full_fam F)->(full_term_pol f)->
 (Ideal g F)->(pol_In_ensemb fi F)->(mi:monom)(full_mon n mi)->
  (equpol f (suma_app g (pol_opp (mult_m fi mi))))->(Ideal f F).

Auto.
Intros.
Apply pol_eq_id_eg with (suma_app g (pol_opp (mult_m fi mi))); Auto.
Apply suma_p_id; Auto.
Apply pol_F_idmult_opp; Trivial.
Apply elem_full with F; Auto.
Save.
*)

Inductive Red_equiv [F:(list pol)] : pol->pol->Prop :=
 Red_equiv_eq: (g,h:pol)(full_fam F)->(full_term_pol g)->
   (full_term_pol h)->(equpol g h)->(Red_equiv F g h)
|Red_equiv_step: (g,h:pol)(full_fam F)->(full_term_pol g)->
   (full_term_pol h)->(Red1 F g h)->(Red_equiv F g h)
|Red_equiv_sym: (g,h:pol)(full_fam F)->(full_term_pol g)-> 
   (full_term_pol h)->(Red_equiv F g h)->
                (Red_equiv F h g)
|Red_equiv_trans: (g,f,h:pol)(full_fam F)-> 
   (full_term_pol g)->(full_term_pol f)->
   (full_term_pol h)->(Red_equiv F g f)->(Red_equiv F f h)->
   (Red_equiv F g h).

Hints Resolve Red_equiv_eq Red_equiv_step Red_equiv_sym Red_equiv_trans.

Lemma Red_equiv_ext: (G : (list pol))(g,h:pol)(Red_equiv G g h)->
   (g':pol)(equpol g g')->(full_term_pol g')->(Red_equiv G g' h).

Intros G g h.
Induction 1; Intros.
Apply Red_equiv_eq; Auto.
Apply equpol_tran with g0; Auto.

Apply Red_equiv_step; Auto.
Apply Red1_ext2 with g0; Auto.

Apply Red_equiv_trans with h0; Auto.

Apply Red_equiv_trans with f; Auto.
Save.

Lemma Red3_equiv : (f,g:pol)(F:(list pol))
 (Red3 F f g)->(Red_equiv F f g).
(Intros f g F r; Elim r).
Auto.
Auto.
 
(Intros g' f' h'; Intros; Apply Red_equiv_trans with f'; 
    Auto).
Save.
Hints Resolve Red3_equiv.

 Lemma Red_equiv_full_l :
(f,g:pol)(F:(list pol))(Red_equiv F f g)->
 (full_term_pol f).
Intros f g F r; Inversion r; Auto.
Save.

Lemma Red_equiv_full_r :
(f,g:pol)(F:(list pol))(Red_equiv F f g)->
 (full_term_pol g).
Intros f g F r; Inversion r; Auto.
Save.

Hints Resolve Red_equiv_full_r Red_equiv_full_l.

Lemma Red_equiv_tran : (f,g,h:pol)(F:(list pol))
  (Red_equiv F f g)->(Red_equiv F g h)->
(Red_equiv F f h).
(Intros f g h F r1 r2; Apply Red_equiv_trans with g; Auto).
(Inversion r1; Auto).
 
(Inversion r1; Auto).
 
(Inversion r1; Auto).
 
(Inversion r2; Auto).
Save.

Lemma Red_equiv_sy :  (f,g:pol)(F:(list pol))
(Red_equiv F f g)->(Red_equiv F g f).
(Intros f g F r; Inversion r; Apply Red_equiv_sym; Auto).
Save.
Hints Resolve Red_equiv_sy.

Lemma con_red_cong: (f,g:pol)(F:(list pol))(Red_equiv F f g)->
                        (Ideal (suma_app f (pol_opp g)) F).
Induction 1; Intros.
Apply ideal_vpol.
Auto.

Apply sum_vpol_opp_inv.
Apply equpol_tran with h; Auto.

Apply Red1_dif_id; Trivial.

Apply pol_eq_id_eg with f:=(pol_opp (suma_app g0 (pol_opp h))); Auto.

Apply pol_eq_id_eg
 with f:=(suma_app (suma_app g0 (pol_opp f0)) (suma_app f0 (pol_opp h)));
  Trivial.
Apply suma_p_id; Trivial.

Auto.
Save.
Hints Resolve con_red_cong.

Lemma conv_congr : 
   (F:(list pol))(f,g:pol)(Red_equiv F f g)->
      (equiv_Id F f g).
Induction 1.
Auto.
 
Auto.
 
Auto.

Intros g1 f1 h fF fg1 ff1 fh Rgf.
(Intros; Apply equiv_id_trans with f1; Auto).
Save.
Hints Resolve conv_congr.

(* De momento estamos probando cambiarlo

Inductive equiv_Id [F:(list pol);f:pol]: pol->Prop :=
   equiv_Id_ref: (f0:pol)(full_fam F)->(full_term_pol f)->
      (full_term_pol f0)->(equpol f f0)->(equiv_Id F f f0)
 | equiv_Id_sum: (g0,g:pol)(full_fam F)->
      (full_term_pol f)->(full_term_pol g0)->
      (full_term_pol g)->(equiv_Id F f g)->
      (h:pol)(full_term_pol h)->(fi:pol)(pol_In_ensemb fi F)->
            (equpol g0 (suma_app g (mult_p h fi)))->
                (equiv_Id F f g0).
Hints Resolve equiv_Id_ref equiv_Id_sum.

Lemma equpol_congr: (p,q,p':pol)(F:(list pol))(equpol p q)-> 
   (full_term_pol q)->(equiv_Id F p p')->(equiv_Id F q p').
Induction 3.
Intros.
(Apply equiv_Id_ref; Auto).
(Apply equpol_tran with p; Auto).

Intros.
(Apply equiv_Id_sum with g:=g h:=h fi:=fi; Auto).
Save.
Hints Resolve equpol_congr.

Lemma equpol_congr1: (p,q,p':pol)(F:(list pol))(equiv_Id F p' p)->
   (equpol p q)->(full_term_pol q)->(equiv_Id F p' q).
Induction 1.
EAuto.
 
Intros.
(Apply equiv_Id_sum with g:=g h:=h fi:=fi; Trivial).
(Apply equpol_tran with g0; Auto).
Save.
Hints Resolve equpol_congr1.

Lemma equiv_id_trans :
 (F:(list pol))(f,g,h:pol)(equiv_Id F f g)->
             (equiv_Id F g h)->(equiv_Id F f h).
Induction 2.
Intros h1 fF fg fh1 eh1.
Apply equpol_congr1 with g; Auto.
 
Intros h1 h2 fF fg fh1 fh2 e1 e2 h3 fh3 fi pi e.
Apply equiv_Id_sum with h2 h3 fi; Auto.
(Inversion e2; Auto).
Save.


Lemma equat_equiv_Id: (f,g,p:pol)(F:(list pol))(full_term_pol f)->(full_term_pol g)->
   (equiv_Id F (suma_app f (pol_opp g)) p)->(equiv_Id F f (suma_app p g)).

Induction 3; Intros.
Apply equiv_Id_ref; Trivial.

Apply full_term_suma_app; Trivial.
 
Apply equpol_tran with (suma_app f (suma_app (pol_opp g) g)).
Apply equpol_tran with (suma_app f vpol).
Auto.

Apply equpol_ss; Auto.
 
Apply equpol_tran with (suma_app (suma_app f (pol_opp g)) g); Auto.

Apply equiv_Id_sum with g:=(suma_app g1 g) h:=h fi:=fi; Trivial.
Apply full_term_suma_app; Trivial.
 
Apply full_term_suma_app; Trivial.
 
Apply equpol_tran with (suma_app g1 (suma_app g (mult_p h fi))).
Apply equpol_tran with (suma_app g1 (suma_app (mult_p h fi) g)).
Apply equpol_tran with (suma_app (suma_app g1 (mult_p h fi)) g); Auto. 
 
Auto.
 
Auto.
Save.
Hints Resolve equat_equiv_Id.

Lemma equiv_Id_cpol: (f,p:pol)(F:(list pol))(full_term_pol p)->
 (~(equpol p vpol))->(equiv_Id F f vpol)->(equiv_Id (cons  p F) f vpol).
Induction 3; Intros; Auto.

Apply equiv_Id_sum with g:=g h:=h fi:=fi; Auto.
Save.
Hints Resolve equiv_Id_cpol.

Lemma Id_congr_vpol: (f:pol)(F:(list pol))(Ideal f F)->(full_fam F)->
                        (equiv_Id F f vpol).

Induction 1; Intros.
Apply equiv_Id_ref; Trivial.

Cut (full_fam F0); Intros.
Cut (equiv_Id F0 p' vpol); Auto; Intros.

Cut (full_term_pol q); Intros.
Cut ~(equpol q vpol); Intros.
Generalize (equiv_Id_cpol p' q F0 H8 H9 H7); Intros.
Cut (equiv_Id (cons q F0) p (suma_app (suma_app p' (pol_opp p)) (mult_p q q'))); 
         Intros.
Apply equpol_congr1 with p:=(suma_app (suma_app p' (pol_opp p)) (mult_p q q')); 
       Trivial.
 
Apply equpol_sym.
Apply equpol_tran with (suma_app p (pol_opp p)).
Auto.
 
Apply equpol_tran with (suma_app p' (suma_app (pol_opp p) (mult_p q q'))).
Apply equpol_tran with (suma_app p' (suma_app (mult_p q q') (pol_opp p))).
Apply equpol_tran with (suma_app (suma_app p' (mult_p q q')) (pol_opp p)).
Apply equpol_tran with (suma_app (suma_app (mult_p q q') p') (pol_opp p)); Auto.
 
Auto.
 
Auto.
 
Auto.
 
Apply equat_equiv_Id; Auto.
 
Cut (equiv_Id (cons q F0) p' (suma_app p' (pol_opp p))); Intros.
Apply equpol_congr with p:=p'; Auto.

Apply equpol_sym.
Apply equpol_tran with 
              (suma_app p' (suma_app (mult_p q q') (pol_opp (mult_p q q')))).
Apply equpol_tran with 
              (suma_app (suma_app p' (mult_p q q')) (pol_opp (mult_p q q'))).
Apply equpol_ss; Trivial.

Apply equpol_tran with (suma_app (mult_p q q') p'); Auto.
 
Auto.
 
Apply equpol_tran with (suma_app p' vpol); Auto.
 
Apply equiv_Id_sum with g:=vpol h:=(pol_opp q') fi:=q; Trivial.

Inversion H2; Auto.
 
Apply full_term_suma_app; Auto.

Inversion H2; Auto.

Auto.
 
Apply equpol_tran with (mult_p (pol_opp q') q); Trivial.

Apply equpol_tran with (mult_p q (pol_opp q')); Trivial.

Apply equpol_tran with (suma_app (mult_p q (pol_opp q')) (suma_app p' (pol_opp p'))).
Apply equpol_tran with (suma_app (suma_app (mult_p q (pol_opp q')) p') (pol_opp p')).
Apply equpol_tran with (suma_app (suma_app p' (mult_p q (pol_opp q'))) (pol_opp p')).
Apply equpol_tran with (suma_app p' (suma_app (mult_p q (pol_opp q')) (pol_opp p')));
         Auto.
 
Auto.
 
Auto.
 
Apply equpol_tran with (suma_app (mult_p q (pol_opp q')) vpol); Auto.
 
Apply nvpol_full_fam with F0; Auto.
 
Apply full_term_full_fam with F0; Auto.
 
Apply cons_full_fam with q; Auto.
Save.
Hints Resolve Id_congr_vpol.

Lemma equiv_Id_en_Id: (f,g:pol)(F:(list pol))(equiv_Id F f g)-> 
                         (Ideal (suma_app g (pol_opp f)) F).

Induction 1.
Intros; Auto.
 
Intros g0 g1 fF ff fg0 fg hg hrg h fh fi ifi e.
Cut (full_term_pol fi); Intros.
Cut (full_term_pol (mult_p h fi)); Intros.
Apply pol_eq_id_eg with (suma_app (suma_app g1 (mult_p h fi)) (pol_opp f)).
Apply pol_eq_id_eg with (suma_app (suma_app g1 (pol_opp f)) (mult_p h fi)).
Apply suma_p_id; Trivial.

Apply pol_eq_id_eg with (mult_p fi h); Trivial.

Apply mult_p_id; Trivial.

Apply pol_F_idF; Trivial.

Apply equpol_tran with (suma_app g1 (suma_app (pol_opp f) (mult_p h fi))); Trivial.

Apply equpol_tran with (suma_app g1 (suma_app (mult_p h fi) (pol_opp f))); Auto.

Apply full_term_suma_app; Auto.

Auto.

Apply full_term_suma_app; Auto.

Apply full_term_mult_p; Auto.

Apply elem_full with F; Trivial.
Save.
Hints Resolve equiv_Id_en_Id.

Lemma equiv_Id_en_Id_inv: (f,g:pol)(F:(list pol))(full_fam F)->(full_term_pol f)->
   (full_term_pol g)->(Ideal (suma_app f (pol_opp g)) F)->(equiv_Id F f g).

Intros.
Apply equpol_congr1 with (suma_app vpol g); Trivial.
Apply equat_equiv_Id; Trivial.
Apply Id_congr_vpol; Trivial.
Save.
Hints Resolve equiv_Id_en_Id_inv.

Lemma inv_Id_congr_vpol: (f:pol)(F:(list pol))(equiv_Id F f vpol)->(Ideal f F).

Intros.
Inversion H.
Auto.

Apply pol_eq_id_eg with (suma_app f (pol_opp vpol)); Trivial.
Apply equiv_Id_en_Id; Auto.
Save.
Hints Resolve inv_Id_congr_vpol.

Inductive Red_equiv [F:(list pol)] : pol->pol->Prop :=
 Red_equiv_eq: (g,h:pol)(full_fam F)->(full_term_pol g)->
   (full_term_pol h)->(equpol g h)->(Red_equiv F g h)
|Red_equiv_step: (g,h:pol)(full_fam F)->(full_term_pol g)->
   (full_term_pol h)->(Red1 F g h)->(Red_equiv F g h)
|Red_equiv_sym: (g,h:pol)(full_fam F)->(full_term_pol g)-> 
   (full_term_pol h)->(Red_equiv F g h)->
                (Red_equiv F h g)
|Red_equiv_trans: (g,f,h:pol)(full_fam F)-> 
   (full_term_pol g)->(full_term_pol f)->
   (full_term_pol h)->(Red_equiv F g f)->(Red_equiv F f h)->
   (Red_equiv F g h).

Hints Resolve Red_equiv_eq Red_equiv_step Red_equiv_sym Red_equiv_trans.

Lemma Red3_equiv : (f,g:pol)(F:(list pol))
 (Red3 F f g)->(Red_equiv F f g).
(Intros f g F r; Elim r).
Auto.
 
Auto.
 
(Intros g' f' h'; Intros; Apply Red_equiv_trans with f'; 
    Auto).
Save.
Hints Resolve Red3_equiv.

 Lemma Red_equiv_full_l :
(f,g:pol)(F:(list pol))(Red_equiv F f g)->
 (full_term_pol f).
Intros f g F r; Inversion r; Auto.
Save.

Lemma Red_equiv_full_r :
(f,g:pol)(F:(list pol))(Red_equiv F f g)->
 (full_term_pol g).
Intros f g F r; Inversion r; Auto.
Save.

Hints Resolve Red_equiv_full_r Red_equiv_full_l.

Lemma Red_equiv_tran : (f,g,h:pol)(F:(list pol))
  (Red_equiv F f g)->(Red_equiv F g h)->
(Red_equiv F f h).
(Intros f g h F r1 r2; Apply Red_equiv_trans with g; Auto).
(Inversion r1; Auto).
 
(Inversion r1; Auto).
 
(Inversion r1; Auto).
 
(Inversion r2; Auto).
Save.

Lemma Red_equiv_sy :  (f,g:pol)(F:(list pol))
(Red_equiv F f g)->(Red_equiv F g f).
(Intros f g F r; Inversion r; Apply Red_equiv_sym; Auto).
Save.
Hints Resolve Red_equiv_sy.

Lemma con_red_cong: (f,g:pol)(F:(list pol))(Red_equiv F f g)->
                        (Ideal (suma_app f (pol_opp g)) F).
Induction 1; Intros.
Apply ideal_vpol.
Auto.

Apply sum_vpol_opp_inv.
Apply equpol_tran with h; Auto.

Apply Red1_dif_id; Trivial.

Apply pol_eq_id_eg with f:=(pol_opp (suma_app g0 (pol_opp h))); Auto.

Apply pol_eq_id_eg
 with f:=(suma_app (suma_app g0 (pol_opp f0)) (suma_app f0 (pol_opp h)));
  Trivial.
Apply suma_p_id; Trivial.

Auto.
Save.
Hints Resolve con_red_cong.


(* Cambiado a reduccion2_tes.
Lemma cons_full_fam: (q:pol)(F:(list pol))
   (full_fam (cons q F))->(full_fam F).
(Induction F; Auto).
Intros.
(Inversion H0; Auto).
Save.
Hints Resolve cons_full_fam.

Lemma nvpol_full_fam: (q:pol)(F:(list pol))
   (full_fam (cons q F))->(~(equpol q vpol)).
Induction q.
Intros.
(Inversion H; Auto).
(Elim H2; Auto).
 
Intros.
(Inversion H0; Auto).
(Elim H3; Auto).
Save.
Hints Resolve nvpol_full_fam.

Lemma full_term_full_fam: (q:pol)(F:(list pol))
   (full_fam (cons q F))->(full_term_pol q).
(Induction q; Auto).
Intros.
Inversion H0.
Elim H3; Auto.
Save.
Hints Resolve full_term_full_fam.
*)

(*
Lemma inv_Id_congr_vpol: (f:pol)(F:(list pol))
   (equiv_Id F f vpol)->(Ideal f F).
Intros.
Cut (Ideal (pol_opp f) F).
Intros.
Apply pol_eq_id_eg with (pol_opp (pol_opp f)).
Apply opp_p_id; Auto.
 
Auto.
 
(Inversion H; Auto).
 
Cut (Ideal (suma_app vpol (pol_opp f)) F).
Intros.
(Apply pol_eq_id_eg with (suma_app vpol (pol_opp f)); Auto).
(Inversion H; Auto).
 
Generalize f F H.
Induction 1.
Intros.
(Apply pol_eq_id_eg with f:=vpol; Auto).
(Apply equpol_tran with (suma_app f1 (pol_opp f1)); Auto).
 
Intros.
(Apply pol_eq_id_eg
  with (suma_app (suma_app g (mult_p h fi)) (pol_opp f0)); Auto).
Apply pol_eq_id_eg
 with (suma_app (suma_app g (pol_opp f0)) (mult_p h fi)).
(Apply suma_p_id; Auto).
(Apply pol_eq_id_eg with (mult_p fi h); Auto).
Apply mult_p_id.
(Apply pol_F_idF; Auto).
(Apply elem_full with F0; Auto).
 
Assumption.
 
Apply full_term_mult_p; Auto.
Apply elem_full with F0; Auto.
 
(Apply equpol_tran
  with (suma_app g (suma_app (pol_opp f0) (mult_p h fi))); Auto).
(Apply equpol_tran
  with (suma_app g (suma_app (mult_p h fi) (pol_opp f0))); Auto).
 
Apply full_term_suma_app; Auto.
Apply full_term_suma_app; Auto.
Apply full_term_mult_p; Auto.
Apply elem_full with F0; Auto.
Save.
Hints Resolve inv_Id_congr_vpol.
*)




Lemma conv_congr : 
   (F:(list pol))(f,g:pol)(Red_equiv F f g)->
      (equiv_Id F f g).
Induction 1.
Auto.
 
Auto.
 
Auto.

Intros g1 f1 h fF fg1 ff1 fh Rgf.
(Intros; Apply equiv_id_trans with f1; Auto).
Save.
Hints Resolve conv_congr.

*)