Require Export Hmtc.

Require Export Relations.

Inductive Tpol_Lex3: pol -> pol -> Prop :=
  Tpol_Lex3_v:   (m:monom)(p:pol)(full_mon n m)->
                    (full_term_pol p)->
                   (Tpol_Lex3 vpol (cpol m p))
 |Tpol_Lex3_car: (m1,m2:monom)(p1,p2:pol)(full_mon n m1)->
   (full_mon n m2)->(full_term_pol p1)->(full_term_pol p2)->
     (Ttm (mon_term m1) (mon_term m2))->
                    (Tpol_Lex3 (cpol m1 p1) (cpol m2 p2))     
 |Tpol_Lex3_cdr: (k1,k2:Q)(t:term)(p1,p2:pol)(full n t)->
    (full_term_pol p1)->(full_term_pol p2)->
     (Tpol_Lex3 p1 p2)->
       (Tpol_Lex3 (cpol (k1,t) p1) (cpol (k2,t) p2)). 
 
Hints Resolve Tpol_Lex3_v Tpol_Lex3_car Tpol_Lex3_cdr.

Lemma ext_l_Tpol_Lex3: (p,q:pol)(Tpol_Lex3 p q)->(full_pol p)->
(full_pol q)->(r:pol)(equpol p r)->(full_pol r)->(Tpol_Lex3 r q).

Intros p q.
Induction 1.
Induction m.
Induction r; Auto.
Induction m0; Intros.
Cut (cpol (a0,b0) p1)=vpol; Intros.
Rewrite H7; Auto.

Apply full_eq_vpol; Auto.

Induction m1; Induction m2.
Induction r; Auto.
Induction m; Intros.
Simpl in H4.
Cut b=b1; Intros.
Apply Tpol_Lex3_car; Auto.
Simpl.
Inversion H9; Auto.

Inversion H9; Auto.

Simpl.
Rewrite <- H10; Trivial.

Transitivity (hterm (cpol (a,b) p1)).
Symmetry; Auto.

Transitivity (hterm (cpol (a1,b1) p0)); Auto.

Induction r; Auto.
Induction m; Intros.
Cut t=b; Intros.
Rewrite H10.
Apply Tpol_Lex3_cdr; Trivial.
Inversion H9; Auto.

Inversion H9; Auto.

Apply H4.
Inversion H9; Auto.
Inversion H5; Auto.

Inversion H6; Auto.

Rewrite H10 in H8.
Cut (eqQ k1 a); Intros.
Apply eq_cpol with (a,b); Auto.
Apply equpol_tran with (cpol (k1,b) p1); Auto.

Apply eqQ_trans with (hcoef (cpol (k1,t) p1)); Auto.
Apply eqQ_trans with (hcoef (cpol (a,b) p0)); Auto.
Apply eq_hcoef; Auto.
Rewrite H10; Auto.

Inversion H9; Auto.

Transitivity (hterm (cpol (k1,t) p1)).
Symmetry; Auto.

Transitivity (hterm (cpol (a,b) p0)); Auto.
Save.

Lemma ext_r_Tpol_Lex3: (p,q:pol)(Tpol_Lex3 p q)->(full_pol p)->
(full_pol q)->(r:pol)(equpol q r)->(full_pol r)->(Tpol_Lex3 p r).

Intros p q.
Induction 1.
Induction m.
Induction r.
Intros.
Inversion H3.
Cut (eqQ a OQ); Intros.
Elim H9; Auto.

Apply eqQ_trans with (hcoef (cpol (a,b) p0)); Auto.
Cut (cpol (a,b) p0)=vpol; Intros.
Rewrite H13.
Apply hcoef_vpol.

Apply full_eq_vpol; Auto.

Induction m0; Intros.
Apply Tpol_Lex3_v.
Simpl.
Inversion H6; Auto.

Inversion H6; Auto.

Induction m1; Induction m2.
Induction r.
Intros.
Simpl in H4.
Cut (cpol (a0,b0) p2)=vpol; Intros.
Rewrite <- H9.
Apply Tpol_Lex3_car; Auto.

Apply full_eq_vpol; Auto.

Induction m; Intros.
Simpl in H4.
Cut b0=b1; Intros.
Rewrite <- H10.
Apply Tpol_Lex3_car; Auto.
Inversion H9; Auto.

Transitivity (hterm (cpol (a0,b0) p2)).
Symmetry; Auto.

Transitivity (hterm (cpol (a1,b1) p0)); Auto.

Induction r.
Intros.
Inversion H6.
Cut (eqQ k2 OQ); Intros.
Elim H12; Auto.

Apply eqQ_trans with (hcoef (cpol (k2,t) p2)); Auto.
Cut (cpol (k2,t) p2)=vpol; Intros.
Rewrite H16.
Apply hcoef_vpol.

Apply full_eq_vpol; Auto.

Induction m; Intros.
Cut t=b; Intros.
Rewrite H10.
Apply Tpol_Lex3_cdr; Auto.
Inversion H9; Auto.

Inversion H9; Auto.

Apply H4.
Inversion H5; Auto.

Inversion H6; Auto.

Rewrite H10 in H8.
Cut (eqQ k2 a); Intros.
Apply eq_cpol with (a,b); Auto.
Apply equpol_tran with (cpol (k2,b) p2); Auto.

Apply eqQ_trans with (hcoef (cpol (k2,t) p2)); Auto.
Apply eqQ_trans with (hcoef (cpol (a,b) p0)); Auto.
Apply eq_hcoef; Auto.
Rewrite H10; Auto.

Inversion H9; Auto.

Transitivity (hterm (cpol (k2,t) p2)).
Symmetry; Auto.

Transitivity (hterm (cpol (a,b) p0)); Auto.
Save.

Theorem Tpol_Lex3_no_refl: (p:pol) ~(Tpol_Lex3 p p).

Induction p.
Red; Intros H; Inversion H.

Intros m p0 H.
Red; Intros H1.
Simple Inversion H1.
Discriminate H3.

Injection H6.
Injection H7.
Intros H8 H9 H10 H11.
Rewrite H11.
Rewrite H9.
Induction m; Simpl; Intros.
Apply (Ttm_nonrefl b); Trivial.

Injection H5; Injection H6.
Intros H9 H10 H11 H12.
Rewrite H9.
Rewrite H11; Intros; Elim H; Trivial.
Save.
Hints Resolve Tpol_Lex3_no_refl.  

Theorem Tpol_Lex3_tran: (p,q,r:pol)(Tpol_Lex3 p q) -> (Tpol_Lex3 q r) ->  (Tpol_Lex3 p r).

Intros p q r H; Generalize r; Clear r; Elim H.
Induction m.
Intros a b p0 fb fp0 r; Case r.
Intros H1; Inversion H1.

Induction m0; Intros.
Apply Tpol_Lex3_v.
Inversion H0; Auto.

Inversion H0; Auto.

Induction m1; Induction m2; Intros.
Simple Inversion H5.
Discriminate H8.

Rewrite <- H12.
Generalize H11; Clear H11.
Elim m3; Elim m0; Intros.
Apply Tpol_Lex3_car; Auto.
Simpl.
Simpl in H10.
Simpl in H4.
Apply Ttm_trans with b0 n; Auto.
Injection H11; Intros.
Rewrite <- H14; Auto.

Rewrite <- H11; Intros.
Apply Tpol_Lex3_car; Auto.
Simpl.
Simpl in H4.
Injection H10; Intros.
Rewrite H13; Trivial.

Intros.
Simple Inversion H5.
Intros.
Discriminate H8.

Rewrite <- H12.
Generalize H11; Clear H11.
Induction m1; Induction m2; Intros.
Apply Tpol_Lex3_car; Auto.
Simpl.
Simpl in H10.
Injection H11; Intros.
Rewrite <- H14; Trivial.

Rewrite <- H11; Intros.
Injection H10; Intros.
Rewrite H13.
Apply Tpol_Lex3_cdr; Auto.
Apply H4.
Rewrite <- H12; Trivial.
Save.

Theorem ext_full_Tpol: (m:monom)(p:pol)(full_pol (cpol m p))->(Tpol_Lex3 p (cpol m vpol)).

Induction m.
Intros a b p; Induction p.
Intros.
Apply Tpol_Lex3_v; Auto.
Inversion H; Auto.

Elim m0; Intros.
Apply Tpol_Lex3_car; Trivial.
Inversion H.
Inversion H5; Auto.

Inversion H; Auto.

Inversion H.
Inversion H5; Auto.

Simpl.
Inversion H.
Inversion H6; Auto.
Save.

(* No lo ponemos porque es el mismo que el anterior, tener cuidado por si utliza con este nombre ms adelante

Theorem p_full_Tpol_monom: (m:monom)(p:pol)(full_pol (cpol m p))->
               (Tpol_Lex3 p (cpol m vpol)).

Induction m.
Intros.
Apply ext_full_Tpol; Auto.
Save.
*)

Theorem Tpol_tran_mon: (m,m1,m2:monom)(p,q:pol)(Tpol_Lex3 (cpol m p) (cpol m1 q))
          ->(full_mon n m2)->(Ttm (mon_term m1) (mon_term m2))->
     (Ttm (mon_term m) (mon_term m2)). 

Induction m; Induction m1; Induction m2.
Intros a1 b1 p q H.
Inversion H.
Intros.
Simpl.
Simpl in H8.
Simpl in H10.
Apply Ttm_trans with b0 n; Auto.

Intro fb1.
Simpl; Trivial.
Save.
Hints Resolve Tpol_tran_mon.

Theorem Tpol_cpol_full: (m:monom)(p:pol)(full_mon n m)->
        (full_pol p)->~(z_monom m)->(Tpol_Lex3 p (cpol m vpol))->
              (full_pol (cpol m p)).

Induction m; Intros.
Apply full_pol_cons; Auto.
Inversion H2; Auto.
Generalize m1 H10 H5; Clear H8 H10 H5 m1.
Induction m1; Auto.

Inversion H10; Auto.
Save.

(* Antes auxiliar0 *)

Lemma s_l_ord_pol: (x,y,z:pol)(full_pol (suma_app x y))->(full_pol (suma_app x z))->
   (Tpol_Lex3 (suma_app x y) (suma_app x z))->(Tpol_Lex3 y z).

Induction x.
Simpl; Trivial.

Induction m.
Simpl; Intros.
Inversion H2.
Simpl in H11.
Cut ~(Ttm b b); Intros; Auto.
Elim H12; Auto.

Apply H; Auto.
Inversion H0; Auto.

Inversion H1; Auto.
Save.

(* Antes auxiliar1 *)

Lemma s_t_ord_p: (b,c:Q)(t,t':term)(x:pol)
(full_pol (suma_app x (cpol (b,t) vpol)))->(full_pol (suma_app x (cpol (c,t') vpol)))->
   (Tpol_Lex3 (suma_app x (cpol (b,t) vpol)) (suma_app x (cpol (c,t') vpol)))->
      (Ttm t t').

Intros.
Cut (Tpol_Lex3 (cpol (b,t) vpol) (cpol (c,t') vpol)); Intros.
Inversion H2.
Simpl in H11; Auto.

Cut ~(Tpol_Lex3 vpol vpol); Intros; Auto.
Elim H13; Auto.

Apply s_l_ord_pol with x; Auto.
Save.

(* Antes auxiliar2 *)

Lemma auxiliar2: (b:Q)(t:term)(x,x0:pol)(full_pol (suma_app x x0))->
   (full n t)->((t':term)(term_in_pol x t')->(Ttm t t'))->
      ((t':term)(term_in_pol x0 t')->(Ttm t' t))->
   (Tpol_Lex3 (suma_app x x0) (suma_app x (cpol (b,t) vpol))). 

Induction x.
Simpl.
Induction x0; Auto.

Induction m; Intros.
Apply Tpol_Lex3_car; Trivial.
Simpl.
Inversion H0; Auto.

Inversion H0; Auto.

Simpl.
Apply H3.
Red.
Red; Intros.
Cut (eqQ (coef (cpol (a,b0) p) b0) a); Intros.
Cut (eqQ OQ a); Intros.
Inversion H0; Auto.

Apply eqQ_trans with (coef (cpol (a,b0) p) b0); Auto.

Apply coef_first; Auto.

Induction m.
Induction x0.
Simpl; Intros.
Cut p=(suma_app p vpol); Intros; Auto.
Rewrite <- H4 in H0.
Inversion H0.
Apply Tpol_Lex3_cdr; Auto.
Apply H; Auto.
Rewrite <- H4; Auto.

Intros.
Apply H2.
Apply full_pol_cons_term; Auto.

Induction m0; Intros.
Cut (full_pol (cpol (a,b0) p)).
Simpl; Intros.
Simpl in H1.
Apply Tpol_Lex3_cdr; Auto.
Inversion H1; Auto.

Inversion H1; Auto.

Apply full_term_suma_app; Auto.
Inversion H5; Auto.

Apply H; Intros; Auto.
Inversion H1; Auto.

Apply H3; Auto.
Apply full_pol_cons_term; Auto.

Elim suma_app_full with (cpol (a,b0) p) (cpol (a0,b1) p0); Auto.
Save.

Definition pol_full := {p:pol | (full_pol p)}.

Definition Tpol_full: pol_full-> pol_full-> Prop :=
   [a,b :pol_full ]
    ( <Prop> Case a of
      [p : pol]
      [H1 : (full_pol p)]
       ( <Prop> Case b of [q: pol] [H2: (full_pol q)]  (Tpol_Lex3 p q) end )
      end ).

Fixpoint pol_Lex_rec [p:pol]: (list term) := Cases p of
   vpol              => (nil ?)
  |(cpol (k,t) p1)   => (cons t (pol_Lex_rec p1))
  end.

Lemma pol_rec_Tpol_lex3: (p,q: pol) (Tpol_Lex3 p q)->(Ltl ? Ttm (pol_Lex_rec p) (pol_Lex_rec q)).

Intros.
Elim H.
Induction m; Simpl; Intros.
Apply (Lt_nil term).

Induction m1; Induction m2; Simpl; Intros.
Apply (Lt_hd term); Trivial.

Simpl; Intros.
Apply (Lt_tl term); Trivial.
Save.
Hints Resolve pol_rec_Tpol_lex3.

Definition Listterm_desc:= [p:pol] (Desc term Ttm (pol_Lex_rec p)).

Lemma Desc_rev: (l:(list term))(t,b:term)(Ttm b t)->(Desc term Ttm (cons b l))->
                  (Desc term Ttm (cons t (cons b l))).

Cut (l':(list term))(b,t:term)
   (Ttm b t)->
   (Desc term Ttm l')->
   (l:?) l'=(cons b l)->
   (Desc term Ttm (cons t l')); EAuto.

Induction 2; Intros.
Discriminate H1.

Apply d_conc with x:=x y:=t l:=(nil term).
Injection H1; Intros.
Rewrite -> H3; Trivial.

Simpl; Constructor.

Apply d_conc with x:=x y:=y l:=(cons t l); Trivial.

Apply H3 with (tail (app l (cons y (nil ?)))).
NewDestruct l; Simpl; Simpl in H4.
Inversion H4; Trivial.

Inversion H4; Trivial.
Save.

Lemma Desc_rev_pol: (p:pol)(t,b:term)(Ttm b t)->(Desc term Ttm (cons b (pol_Lex_rec p)))->
                         (Desc term Ttm (cons t (cons b (pol_Lex_rec p)))). 

Intros.
Apply Desc_rev; Auto.
Save.

Lemma ayuda_full_imp_lis_desc: (p:pol)(t:term)(full_pol p)->
(full n t)->(low_pol t p)->(Desc term Ttm (cons t (pol_Lex_rec p))).

Induction p.
Intros; Simpl.
Apply d_one.

Induction m; Intros; Simpl.
Apply Desc_rev_pol.
Inversion H2; Auto.

Apply H; Inversion H0; Auto.
Save.

Theorem full_imp_lis_desc: (p:pol)(full_pol p)->(Listterm_desc p).

Induction p.
Intros.
Red.
Simpl.
Apply d_nil.

Induction m; Intros.
Inversion H0.
Red.
Simpl.
Apply ayuda_full_imp_lis_desc; Auto.
Save.

Definition pol_recpol: pol_full->(Pow term Ttm) :=
   [a: pol_full]
    ( <(Pow term Ttm)> Case a of
      [p: pol]
      [H: (full_pol p)]  (exist (list term) (Desc term Ttm) (pol_Lex_rec p) (full_imp_lis_desc p H))
      end).

Lemma pol_rec_Tpol:(p,q: pol_full)(Tpol_full p q)->
   (lex_exp term Ttm (pol_recpol p)(pol_recpol q)).

Intros p q; Case p; Case q.
Unfold lex_exp; Simpl; Intros.
Apply pol_rec_Tpol_lex3; Trivial.
Save.

Theorem Tpol_full_wf: (well_founded pol_full Tpol_full).

LApply (wf_inverse_image pol_full (Pow term Ttm) (lex_exp term Ttm)
         pol_recpol).
Intros H'3.
Apply wf_incl
 with R2:=[x,y:pol_full]
           (lex_exp term Ttm (pol_recpol x) (pol_recpol y)).
Red; Intros.
Apply pol_rec_Tpol; Trivial.

Auto.

Apply (wf_lex_exp term Ttm); Apply Ttm_wf.
Save.

Definition inc: pol_full -> pol :=
   [p:pol_full] (Case p of
    [q:pol][H:(full_pol q)] q
 end).

Fixpoint inc_list [p:(list pol_full)]: (list pol) := Cases p of
   nil              => (nil ?)
  |(cons p1 p2)   => (cons (inc p1) (inc_list p2))
  end.

Lemma ex_fpol:(f:pol_full){g:pol|(full_pol g)/\(equpol (inc f) g)}.
Induction f.
Simpl; Intros.
Split with x; Auto.
Save.

Lemma ex_fpol_eq:(f:pol)(full_pol f)->{g:pol_full|(equpol f (inc g))}.
Intros.
Split with (exist pol [x:pol](full_pol x) f H); Simpl; Auto.
Save.

Lemma pol_f_impl_f_pol:(f:pol_full)(full_pol (inc f)).
Induction f; Intros; Simpl; Trivial.
Save.
Hints Resolve pol_f_impl_f_pol.

(* En principio no hace falta se resuelve con Auto *)

Lemma pol_f_impl_f_term:(f:pol_full)(full_term_pol (inc f)).
Intros.
Cut (full_pol (inc f)); Intros; Auto.
Save.

(* Lo siguiente es vlido pero lo pasaremos a otros ficheros

(* Intentamos poner todo lo hecho en pol para pol_full *)

Definition inc_red: pol_full -> pol_full -> pol_full -> Prop :=
  [p,q,r:pol_full] (red (inc p)  (inc q) (inc r)).

Lemma aux1_red_menor2: (a:Q)(b,t:term)(p,x:pol)(full_pol (cpol (a,b) p))->
(term_in_pol (cpol (a,b) p) t)->~(equpol x vpol)->(full_term_pol x)->
   (equpol (cpol (a,b) p)
          (suma_app x (cpol ((coef (cpol (a,b) p) t),t) vpol)))->
       ((t':term)(term_in_pol x t')->(Ttm t t'))->(term_in_pol p t).

Intros.
Elim (eq_tm_dec t b); Intros.
Rewrite <- a0 in H.
Rewrite <- a0 in H0.
Cut (hterm (cpol (a,t) p))=t; Intros.
Cut (Ttm t (hterm (cpol (a,t) p))); Intros.
Rewrite H5 in H6.
Cut ~(Ttm t t); Intros; Auto.
Elim H7; Auto.

Rewrite <- a0 in H3.
Replace (hterm (cpol (a,t) p))
 with (hterm (suma_app x (cpol ((coef (cpol (a,t) p) t),t) vpol))).
Replace (hterm (suma_app x (cpol ((coef (cpol (a,t) p) t),t) vpol)))
 with (hterm x); Auto.
Symmetry.
Apply hterm_suma_Ttm; Auto.
Apply full_term_pol_cons; Auto.
Inversion H; Auto.

Replace (hterm (cpol ((coef (cpol (a,t) p) t),t) vpol)) with t; Auto.
Symmetry.
Apply full_hterm.
Apply full_pol_cons; Auto.
Inversion H; Auto.

Apply eq_hterm; Auto.
Apply full_term_suma_app; Auto.
Apply full_term_pol_cons; Auto.
Inversion H; Auto.

Apply full_hterm; Auto.

Red.
Red; Intros.
Red in H0.
Apply H0.
Apply eqQ_trans with (coef p t); Trivial.
Apply coef_n_term; Trivial.
Save.

Lemma aux2_red_menor2: (a:Q)(b,t:term)(p,x,x0:pol)(full_pol (cpol (a,b) p))->
(term_in_pol (cpol (a,b) p) t)->~(equpol x vpol)->~(equpol x0 vpol)->
   (full_term_pol x)->(full_term_pol x0)->
   (equpol (cpol (a,b) p)
          (suma_app x
            (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol) x0)))->
       ((t':term)(term_in_pol x t')->(Ttm t t'))->((t':term)(term_in_pol x0 t')->(Ttm t' t))->(term_in_pol p t).

Intros.
Elim (eq_tm_dec t b); Intros.
Rewrite <- a0 in H.
Rewrite <- a0 in H0.
Cut (hterm (cpol (a,t) p))=t; Intros; Auto.
Cut (Ttm t (hterm (cpol (a,t) p))); Intros.
Rewrite H8 in H9.
Cut ~(Ttm t t); Intros; Auto.
Elim H10; Auto.

Rewrite <- a0 in H5.
Replace (hterm (cpol (a,t) p))
 with (hterm
        (suma_app x
          (suma_app (cpol ((coef (cpol (a,t) p) t),t) vpol) x0))).
Replace (hterm
          (suma_app x
            (suma_app (cpol ((coef (cpol (a,t) p) t),t) vpol) x0)))
 with (hterm x); Auto.
Symmetry.
Apply hterm_suma_Ttm; Auto.
Apply full_term_suma_app; Auto.
Apply full_term_pol_cons; Auto.
Inversion H; Auto.

Replace (hterm (suma_app (cpol ((coef (cpol (a,t) p) t),t) vpol) x0))
 with t; Auto.
Symmetry.
Transitivity (hterm (cpol ((coef (cpol (a,t) p) t),t) vpol)).
Apply hterm_suma_Ttm; Auto.
Apply full_term_pol_cons; Auto.
Inversion H; Auto.

Replace (hterm (cpol ((coef (cpol (a,t) p) t),t) vpol)) with t; Auto.
Symmetry.
Apply full_hterm.
Apply full_pol_cons; Auto.
Inversion H; Auto.

Apply full_hterm.
Apply full_pol_cons; Auto.
Inversion H; Auto.

Apply eq_hterm; Auto.
Apply full_term_suma_app; Auto.
Apply full_term_suma_app; Auto.
Apply full_term_pol_cons; Auto.
Inversion H; Auto.

Red.
Red; Intros.
Red in H0.
Apply H0.
Apply eqQ_trans with (coef p t); Auto.
Save.

Lemma red_menor2: (f,g,fi:pol_full)(inc_red fi f g)->(Tpol_full g f).

(* Desdoblamos las definiciones de pol_full e inc_red quedando como full y red normal *)

Unfold inc_red.
Unfold Tpol_full.
Induction f.
Simpl.
Clear f.
Intros f ff.
Induction g.
Simpl.
Clear g.
Intros g fg.
Induction fi.
Simpl.
Clear fi.
Intros fi ffi.
Generalize f ff g fg fi ffi.
Clear ffi fi fg g ff f.


(* Induccion sobre f *)

(* Caso f=vpol *)

Induction f.
Intros.
Inversion H.
Elim H0.
Simpl; Auto.

Induction m.

(* Induccion sobre g *)

(* Caso g=vpol *)

Induction g.
Intros.
Apply Tpol_Lex3_v; Trivial.
Inversion ff.
Simpl; Trivial.

Inversion ff; Auto.

Induction m0; Intros.

(* Caso (Tpol_Lex3 (cpol (a0,b0) p0) (cpol (a,b) p)) *)

Inversion H1.
Inversion ff.
Inversion fg.
Cut (full_term_pol p); Intros.
Cut (full_term_pol p0); Intros.

Elim (vpol_dec_full_term (cpol (a0,b0) p0)); Trivial; Intros.


(* Subcaso (equpol (cpol (a0,b0) p0) vpol) *)


Cut (cpol (a0,b0) p0)=vpol; Intros.
Rewrite H25; Auto.

Apply full_eq_vpol; Trivial.

(* Subcaso ~(equpol (cpol (a0,b0) p0) vpol) *)

Cut (no_term_in_pol (cpol (a0,b0) p0) t); Intros.
Cut (hterm
      (pol_opp
        (mult_m fi
          ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
           (div_term t (hterm fi))))))=t; Intros.

(* Desdoblamos (cpol (a,b) p) en x+(c,t)+x0 *)


Elim split_pol with (cpol (a,b) p) t; Trivial; Intros.
Elim H28; Intros.
Clear H28.
Elim H27; Intros; Clear H27.
Elim H29; Intros; Clear H29.
Cut (full n t); Intros.
Cut ~(equpol (cpol (a,b) p) vpol); Intros.
Cut (eqQ
      (hcoef
        (pol_opp
          (mult_m fi
            ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
             (div_term t (hterm fi))))))
      (multQ_neg (coef (cpol (a,b) p) t))); Intros.
Cut (full_pol (cpol ((coef (cpol (a,b) p) t),t) vpol)); Intros.
Cut (full_term_pol (suma_app x (cpol ((coef (cpol (a,b) p) t),t) vpol)));
Intros.
Cut (full_term_pol
      (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol) x0)); Intros.
Cut ~(z_monom
       ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
        (div_term t (hterm fi)))).
Cut ~(equpol
       (pol_opp
         (mult_m fi
           ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
            (div_term t (hterm fi))))) vpol); Intros.
Cut (full_term_pol
      (pol_opp
        (mult_m fi
          ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
           (div_term t (hterm fi)))))); Intros.
Cut (full_mon n
      ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
       (div_term t (hterm fi)))); Intros.

Elim (vpol_dec_full_term x); Trivial; Intros.
Elim (vpol_dec_full_term x0); Trivial; Intros.

(* Subsubcaso (equpol x vpol) y (equpol x0 vpol) *)

Cut (equpol (cpol (a,b) p) (cpol ((coef (cpol (a,b) p) t),t) vpol));
Intros.
Apply Tpol_Lex3_car; Auto.
Simpl.
Replace b0 with (hterm (cpol (a0,b0) p0)); Auto.
Replace b with (hterm (cpol (a,b) p)); Auto.
Replace (hterm (cpol (a0,b0) p0))
 with (hterm
        (suma_app (cpol (a,b) p)
          (pol_opp
            (mult_m fi
              ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
               (div_term t (hterm fi))))))); Auto.
Replace (hterm
          (suma_app (cpol (a,b) p)
            (pol_opp
              (mult_m fi
                ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
                 (div_term t (hterm fi)))))))
 with (hterm
        (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol)
          (pol_opp
            (mult_m fi
              ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
               (div_term t (hterm fi))))))); Auto.
Replace (hterm (cpol (a,b) p))
 with (hterm (cpol ((coef (cpol (a,b) p) t),t) vpol)); Auto.
Apply hterm_eq_suma_Ttm; Auto.
Apply eq_nvpol with (cpol (a0,b0) p0); Trivial.
Apply equpol_tran
 with (suma_app (cpol (a,b) p)
        (pol_opp
          (mult_m fi
            ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
             (div_term t (hterm fi)))))); Trivial.
Apply equpol_ss; Auto.

Apply eqQ_trans with (coef (cpol (a,b) p) t).
Apply full_hcoef; Auto.

Apply eqQ_trans
 with (hcoef
        (mult_m fi
          ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
           (div_term t (hterm fi))))).
Apply eqQ_trans
 with (multQ (hcoef fi)
        (mon_coef
          ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
           (div_term t (hterm fi))))).
Unfold mon_coef.
Apply eqQ_sym.
Apply eqQ_trans
 with (multQ (divQ (coef (cpol (a,b) p) t) (hcoef fi)) (hcoef fi)).
Auto.

Apply eqQ_trans
 with (divQ (multQ (coef (cpol (a,b) p) t) (hcoef fi)) (hcoef fi)).
Auto.

Apply eqQ_trans
 with (divQ (multQ (hcoef fi) (coef (cpol (a,b) p) t)) (hcoef fi));
Auto.

Apply eqQ_sym.
Apply hcoef_mult; Trivial.

Apply hcoef_pol_opp_term; Auto.

Transitivity t.
Apply full_hterm; Auto.

Symmetry; Auto.

Apply equpol_tran
 with (suma_app x (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol) x0));
Auto.
Apply equpol_tran
 with (suma_app vpol
        (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol) vpol)); Auto.


(* Subsubcaso (equpol x vpol) y ~(equpol x0 vpol) *)

Cut (equpol (cpol (a,b) p)
      (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol) x0)); Intros.
Cut (hterm (cpol (a,b) p))=t; Intros.
Cut (eqQ (hcoef (cpol (a,b) p))
      (hcoef (cpol ((coef (cpol (a,b) p) t),t) vpol))); Intros.
Cut (equpol (cpol (a0,b0) p0)
      (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol)
        (suma_app x0
          (pol_opp
            (mult_m fi
              ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
               (div_term t (hterm fi)))))))); Intros.
Cut (hterm (cpol (a,b) p))
     =(hterm (cpol ((coef (cpol (a,b) p) t),t) vpol)); Intros.
Apply Tpol_Lex3_car; Auto.
Simpl.
Replace b0 with (hterm (cpol (a0,b0) p0)); Auto.
Replace b with (hterm (cpol (a,b) p)); Auto.
Replace (hterm (cpol (a0,b0) p0))
 with (hterm
        (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol)
          (suma_app x0
            (pol_opp
              (mult_m fi
                ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
                 (div_term t (hterm fi)))))))); Auto.

Rewrite H46.
Apply hterm_eq_suma_Ttm; Auto.
Apply eq_nvpol with (cpol (a0,b0) p0); Trivial.

Apply eqQ_trans
 with (multQ_neg
        (hcoef
          (pol_opp
            (mult_m fi
              ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
               (div_term t (hterm fi))))))).
Apply eqQ_trans
 with (hcoef
        (mult_m fi
          ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
           (div_term t (hterm fi))))); Auto.
Apply eqQ_trans
 with (multQ (hcoef fi)
        (mon_coef
          ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
           (div_term t (hterm fi))))).
Unfold mon_coef.
Apply eqQ_trans with (coef (cpol (a,b) p) t); Auto.
Apply eqQ_sym.
Apply eqQ_trans
 with (multQ (divQ (coef (cpol (a,b) p) t) (hcoef fi)) (hcoef fi));
Auto.
Apply eqQ_trans
 with (divQ (multQ (coef (cpol (a,b) p) t) (hcoef fi)) (hcoef fi));
Auto.
Apply eqQ_trans
 with (divQ (multQ (hcoef fi) (coef (cpol (a,b) p) t)) (hcoef fi));
Auto.

Apply eqQ_sym.
Apply hcoef_mult; Trivial.

Apply eq_mulQ_neg.
Apply eqQ_trans
 with (hcoef
        (suma_app
          (pol_opp
            (mult_m fi
              ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
               (div_term t (hterm fi))))) x0)); Auto.
Apply hcoef_suma_Ttm; Trivial.


Rewrite H26; Apply H32; Auto.


Symmetry.
Transitivity (hterm
               (suma_app
                 (pol_opp
                   (mult_m fi
                     ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
                      (div_term t (hterm fi))))) x0)); Auto.

Transitivity (hterm
               (pol_opp
                 (mult_m fi
                   ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
                    (div_term t (hterm fi)))))).
Apply hterm_suma_Ttm; Auto.

Rewrite H26; Apply H32; Auto.

Transitivity t; Trivial.
Symmetry; Auto.

Transitivity t; Trivial.
Symmetry; Apply full_hterm; Auto.

Apply equpol_tran
 with (suma_app (cpol (a,b) p)
        (pol_opp
          (mult_m fi
            ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
             (div_term t (hterm fi)))))); Auto.
Apply equpol_tran
 with (suma_app (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol) x0)
        (pol_opp
          (mult_m fi
            ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
             (div_term t (hterm fi)))))); Auto.


Apply eqQ_trans with (coef (cpol (a,b) p) (hterm (cpol (a,b) p))); Auto.
Apply eqQ_sym.
Apply eqQ_trans
 with (coef (cpol ((coef (cpol (a,b) p) t),t) vpol)
        (hterm (cpol ((coef (cpol (a,b) p) t),t) vpol))); Auto.

Rewrite H43.

Replace (hterm (cpol ((coef (cpol (a,b) p) t),t) vpol)) with t.
Simpl.
Elim (eq_tm_dec t t).
Intros.
Elim (eq_tm_dec t b); Intros; Auto.

Intro e; Elim e; Auto.

Symmetry; Auto.

Transitivity (hterm
               (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol) x0));
Auto.
Transitivity (hterm (cpol ((coef (cpol (a,b) p) t),t) vpol)); Auto.
Apply hterm_suma_Ttm; Auto.
Replace (hterm (cpol ((coef (cpol (a,b) p) t),t) vpol)) with t; Auto.
Symmetry.
Apply full_hterm; Auto.

Apply equpol_tran
 with (suma_app x (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol) x0));
Trivial.
Apply equpol_tran
 with (suma_app vpol
        (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol) x0)); Auto.

(Elim (vpol_dec_full_term x0); Trivial; Intros).

(* Caso x=/ vpol y x0=vpol  *)


Cut (equpol (cpol (a,b) p)
      (suma_app x (cpol ((coef (cpol (a,b) p) t),t) vpol))); Intros.
Cut b0=b; Intros.
Rewrite <- H43.
Apply Tpol_Lex3_cdr; Auto.
Apply H with fi; Auto.
Apply red1_simpl with t; Auto.
Apply aux1_red_menor2 with a b x; Auto.

Apply eq_cpol with (a,b).
Apply equpol_tran with (cpol (a0,b0) p0).
Apply eq_mon_cpol.
Rewrite H43.
Red.
Right.
Split; Auto.
Apply eqQ_trans with (hcoef (cpol (a,b) p)); Auto.
Apply eqQ_trans with (hcoef (cpol (a0,b0) p0)); Auto.
Apply eqQ_trans
 with (hcoef
        (suma_app (cpol (a,b) p)
          (pol_opp
            (mult_m fi
              ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
               (div_term t (hterm fi))))))); Auto.
Apply eqQ_sym.
Apply hcoef_suma_Ttm; Auto.
Rewrite H26.
Replace (hterm (cpol (a,b) p))
 with (hterm (suma_app x (cpol ((coef (cpol (a,b) p) t),t) vpol)));
Auto.
Replace (hterm (suma_app x (cpol ((coef (cpol (a,b) p) t),t) vpol)))
 with (hterm x); Auto.
Symmetry.
Apply hterm_suma_Ttm; Auto.
Replace (hterm (cpol ((coef (cpol (a,b) p) t),t) vpol)) with t; Auto.
Symmetry.
Apply term_monom_hterm; Auto.

Apply equpol_tran
 with (suma_app (cpol (a,b) p)
        (pol_opp
          (mult_m fi
            ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
             (div_term t (hterm fi)))))); Auto.
Apply equpol_tran
 with (cpol (a,b)
        (suma_app p
          (pol_opp
            (mult_m fi
              ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
               (div_term t (hterm fi))))))); Auto.

Apply equpol_cpol.
Apply monot_suma_l.
Apply opp_comp.
Apply mult_pm_comp_2.
Red.
Right.
Split; Auto.
Apply eg_denomQ; Auto.
Cut (term_in_pol p t); Intros.
Simpl.
Elim (eq_tm_dec t b); Intros; Auto.
Rewrite <- a4 in ff.
Cut (no_term_in_pol p t); Intros.
Red in H44.
Red in H45.
Elim H44; Auto.

Apply full_no_term with a; Auto.

Apply aux1_red_menor2 with a b x; Auto.

Transitivity (hterm (cpol (a,b) p)); Auto.
Transitivity (hterm (cpol (a0,b0) p0)).
Symmetry; Auto.

Transitivity (hterm
               (suma_app (cpol (a,b) p)
                 (pol_opp
                   (mult_m fi
                     ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
                      (div_term t (hterm fi))))))); Auto.
Apply hterm_suma_Ttm; Auto.
Rewrite H26.
Replace (hterm (cpol (a,b) p)) with b.
Apply H31.
Cut (term_in_pol p t); Intros.
Cut ~b=t; Intros.
Cut (term_in_pol (suma_app x (cpol ((coef (cpol (a,b) p) t),t) vpol)) b);
Intros.
Elim (term_in_sum x (cpol ((coef (cpol (a,b) p) t),t) vpol) b); Intros;
Auto.
Cut b=t; Intros.
Elim H44; Auto.

Apply eq_term_in_pol_monom with (coef (cpol (a,b) p) t); Auto.

Apply comp_term_in_pol with (cpol (a,b) p); Auto.
Replace b with (hterm (cpol (a,b) p)); Auto.
Replace (cpol (a,(hterm (cpol (a,b) p))) p) with (cpol (a,b) p); Auto.
Replace (hterm (cpol (a,b) p)) with b; Auto.
Symmetry; Auto.

Red; Intros.
Rewrite <- H44 in H43.
Cut (no_term_in_pol p b); Intros; Auto.
Apply full_no_term with a; Auto.

Apply aux1_red_menor2 with a b x; Auto.

Symmetry; Auto.

Apply equpol_tran
 with (suma_app x (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol) x0));
Auto.
Apply equpol_tran
 with (suma_app x
        (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol) vpol)); Auto.

(* falta el caso en que x y x0 son distintos de vpol*)

Cut b0=b; Intros.
Rewrite <- H42.
Apply Tpol_Lex3_cdr; Auto.
Apply H with fi; Auto.
Apply red1_simpl with t; Auto.
Apply aux2_red_menor2 with a b x x0; Auto.

Apply eq_cpol with (a,b).
Apply equpol_tran with (cpol (a0,b0) p0).
Apply eq_mon_cpol.
Rewrite H42.
Red.
Right.
Split; Auto.
Apply eqQ_trans with (hcoef (cpol (a,b) p)); Auto.
Apply eqQ_trans with (hcoef (cpol (a0,b0) p0)); Auto.
Apply eqQ_trans
 with (hcoef
        (suma_app (cpol (a,b) p)
          (pol_opp
            (mult_m fi
              ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
               (div_term t (hterm fi))))))); Auto.
Apply eqQ_sym.
Apply hcoef_suma_Ttm; Auto.
Rewrite H26.
Replace (hterm (cpol (a,b) p))
 with (hterm
        (suma_app x
          (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol) x0))); Auto.
Replace (hterm
          (suma_app x
            (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol) x0)))
 with (hterm x); Auto.
Symmetry.
Apply hterm_suma_Ttm; Auto.
Replace (hterm (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol) x0))
 with t; Auto.
Symmetry.
Transitivity (hterm (cpol ((coef (cpol (a,b) p) t),t) vpol)); Auto.
Apply hterm_suma_Ttm; Auto.
Replace (hterm (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol) x0))
 with t.
Replace (hterm (cpol ((coef (cpol (a,b) p) t),t) vpol)) with t; Auto.
Symmetry.
Apply term_monom_hterm; Auto.

Symmetry.
Transitivity (hterm (cpol ((coef (cpol (a,b) p) t),t) vpol)); Auto.
Apply hterm_suma_Ttm; Auto.
Replace (hterm (cpol ((coef (cpol (a,b) p) t),t) vpol)) with t; Auto.
Symmetry.
Apply term_monom_hterm; Auto.

Apply equpol_tran
 with (suma_app (cpol (a,b) p)
        (pol_opp
          (mult_m fi
            ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
             (div_term t (hterm fi)))))); Auto.
Apply equpol_tran
 with (cpol (a,b)
        (suma_app p
          (pol_opp
            (mult_m fi
              ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
               (div_term t (hterm fi))))))); Auto.

Apply equpol_cpol.
Apply monot_suma_l.
Apply opp_comp.
Apply mult_pm_comp_2.
Red.
Right.
Split; Auto.
Apply eg_denomQ; Auto.
Cut (term_in_pol p t); Intros.
Simpl.
Elim (eq_tm_dec t b); Intros; Auto.
Rewrite <- a3 in ff.
Cut (no_term_in_pol p t); Intros.
Red in H43.
Red in H44.
Elim H43; Auto.

Apply full_no_term with a; Auto.

Apply aux2_red_menor2 with a b x x0; Auto.

Transitivity (hterm (cpol (a,b) p)); Auto.
Transitivity (hterm (cpol (a0,b0) p0)); Auto.
Symmetry; Auto.

Transitivity (hterm
               (suma_app (cpol (a,b) p)
                 (pol_opp
                   (mult_m fi
                     ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
                      (div_term t (hterm fi))))))); Auto.
Apply hterm_suma_Ttm; Auto.
Rewrite H26.
Replace (hterm (cpol (a,b) p))
 with (hterm
        (suma_app x
          (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol) x0)));
Intros.
Replace (hterm
          (suma_app x
            (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol) x0)))
 with (hterm x); Intros.
Apply H31; Auto.

Symmetry.
Apply hterm_suma_Ttm; Auto.
Apply Ttm_suma_hterm; Auto.
Replace (hterm (cpol ((coef (cpol (a,b) p) t),t) vpol)) with t; Auto.
Symmetry.
Apply term_monom_hterm; Auto.

Apply Ttm_trans with t n; Auto.

Auto.

Auto.

Auto.

Apply no_eq_no_vpol_opp.
Apply contr_mult_nz_monom; Trivial.
Apply no_divQ_zero; Auto.

Auto.

Unfold z_monom.
Apply no_divQ_zero; Auto.

Auto.

Auto.

Auto.

Apply eqQ_trans
 with (multQ_neg
        (hcoef
          (pol_opp
            (pol_opp
              (mult_m fi
                ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
                 (div_term t (hterm fi)))))))).
Apply hcoef_pol_opp_term; Auto.

Apply eq_mulQ_neg.
Apply eqQ_trans
 with (hcoef
        (mult_m fi
          ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
           (div_term t (hterm fi))))).
Apply eqQ_trans
 with (multQ (hcoef fi)
        (mon_coef
          ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
           (div_term t (hterm fi))))).
Unfold mon_coef.
Apply eqQ_sym.
Apply eqQ_trans
 with (multQ (divQ (coef (cpol (a,b) p) t) (hcoef fi)) (hcoef fi));
Auto.
Apply eqQ_trans
 with (divQ (multQ (coef (cpol (a,b) p) t) (hcoef fi)) (hcoef fi));
Auto.
Apply eqQ_trans
 with (divQ (multQ (hcoef fi) (coef (cpol (a,b) p) t)) (hcoef fi));
Auto.

Apply eqQ_sym.
Apply hcoef_mult; Trivial.
Simpl; Auto.

Apply eq_hcoef; Auto.
Apply full_term_opp; Auto.

EAuto.

Apply full_coef with (cpol (a,b) p); Trivial.

Transitivity (hterm
               (mult_m fi
                 ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
                  (div_term t (hterm fi))))).
Symmetry.
Apply hterm_pol_opp_term.
Apply full_mult_m; Auto.
Apply term_div_full; Auto.
Apply full_coef with (cpol (a,b) p); Trivial.

Transitivity (term_mult (hterm fi)
               (mon_term
                 ((divQ (coef (cpol (a,b) p) t) (hcoef fi)),
                  (div_term t (hterm fi))))).
Apply hterm_mult_m; Trivial.
Simpl.
Apply term_div_full; Auto.
Apply full_coef with (cpol (a,b) p); Trivial.

Unfold z_monom.
Apply no_divQ_zero; Auto.

Simpl.
Symmetry.
Apply divis_im_divt with n; Trivial.
EAuto.

Apply full_coef with (cpol (a,b) p); Trivial.

Apply elim_red_exp with fi (cpol (a,b) p).
Apply red1_exp_simpl
 with (div_term t (hterm fi)) (divQ (coef (cpol (a,b) p) t) (hcoef fi));
Trivial.
Apply term_div_full; Auto.
Apply full_coef with (cpol (a,b) p); Trivial.

Transitivity (term_mult (hterm fi) (div_term t (hterm fi))); Auto.
Apply divis_im_divt with n; Auto.
Apply full_coef with (cpol (a,b) p); Trivial.

Inversion fg; Auto.

Inversion H3; Auto.
Save.

(* Ver si lo anterior se puede poner con full_pol fuera me parece que esta hecho en la demostracion anterior *)

(*
Lemma red_menor2_fp: (f:pol)(full_pol f)->(g:pol)(full_pol g)->
    (fi:pol)(full_pol fi)->(red fi f g)->(Tpol_Lex3 g f).

Habria que cambiar notaciones pero sale IMPORTANTE

*)

Definition simetrico [A:Set;R:A -> A -> Prop; a,b:A] : Prop :=
(R b a).

Definition noetheriano := [A:Set][R:A -> A -> Prop]
                 (well_founded A (simetrico A R)).

(* CUIDADO ESTO TAMBIEN ESTA DEFINIDO EN S_poly *)

Lemma buen_ord_red: (fi:pol_full)(noetheriano ? (inc_red fi)).
Red; Intros.
Apply wf_incl with Tpol_full.
Red; Intros.
Red in H.
Apply red_menor2 with fi; Trivial.

Apply Tpol_full_wf.
Save.

Definition inc_Red1: (list pol_full)->pol_full->pol_full->Prop :=
  [F:(list pol_full)][p,q:pol_full] (Red1 (inc_list F)  (inc p) (inc q)).

Lemma Red1_menor2: (F:(list pol_full))(f,g:pol_full)(inc_Red1 F f g)->(Tpol_full g f).

(* Desdoblamos las definiciones de pol_full e inc_red quedando como full y red normal *)

Unfold inc_Red1.
Unfold Tpol_full.
Induction f.
Simpl.
Clear f.
Intros f ff.
Induction g.
Simpl.
Clear g.
Intros g fg.
Induction 1.
Clear H.
Intros.
Clear H.
Clear H0.
Clear F.
Generalize H1.
Generalize f0.
Clear H1 f0.
Generalize f ff g fg.
Clear fg g ff f.

(* Induccion sobre f *)

(* Caso f=vpol *)

Induction f.
Intros.
Inversion H1.
Elim H.
Simpl; Auto.

Induction m.

(* Induccion sobre g *)

(* Caso g=vpol *)

Induction g.
Intros.
Apply Tpol_Lex3_v; Trivial.
Inversion ff.
Simpl; Trivial.

Inversion ff; Auto.

Induction m0; Intros.

(* Caso (Tpol_Lex3 (cpol (a0,b0) p0) (cpol (a,b) p)) *)

Inversion H1.
Inversion ff.
Inversion fg.
Cut (full_term_pol p); Intros.
Cut (full_term_pol p0); Intros.

Elim (vpol_dec_full_term (cpol (a0,b0) p0)); Trivial; Intros.


(* Subcaso (equpol (cpol (a0,b0) p0) vpol) *)


Cut (cpol (a0,b0) p0)=vpol; Intros.
Rewrite H25; Auto.

Apply full_eq_vpol; Trivial.

(* Subcaso ~(equpol (cpol (a0,b0) p0) vpol) *)

Cut (no_term_in_pol (cpol (a0,b0) p0) t); Intros.
Cut (hterm
      (pol_opp
        (mult_m f0
          ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
           (div_term t (hterm f0))))))=t; Intros.

(* Desdoblamos (cpol (a,b) p) en x+(c,t)+x0 *)


Elim split_pol with (cpol (a,b) p) t; Trivial; Intros.
Elim H28; Intros.
Clear H28.
Elim H27; Intros; Clear H27.
Elim H29; Intros; Clear H29.
Cut (full n t); Intros.
Cut ~(equpol (cpol (a,b) p) vpol); Intros.
Cut (eqQ
      (hcoef
        (pol_opp
          (mult_m f0
            ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
             (div_term t (hterm f0))))))
      (multQ_neg (coef (cpol (a,b) p) t))); Intros.
Cut (full_pol (cpol ((coef (cpol (a,b) p) t),t) vpol)); Intros.
Cut (full_term_pol (suma_app x (cpol ((coef (cpol (a,b) p) t),t) vpol)));
Intros.
Cut (full_term_pol
      (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol) x0)); Intros.
Cut ~(z_monom
       ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
        (div_term t (hterm f0)))).
Cut ~(equpol
       (pol_opp
         (mult_m f0
           ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
            (div_term t (hterm f0))))) vpol); Intros.
Cut (full_term_pol
      (pol_opp
        (mult_m f0
          ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
           (div_term t (hterm f0)))))); Intros.
Cut (full_mon n
      ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
       (div_term t (hterm f0)))); Intros.

Elim (vpol_dec_full_term x); Trivial; Intros.
Elim (vpol_dec_full_term x0); Trivial; Intros.

(* Subsubcaso (equpol x vpol) y (equpol x0 vpol) *)

Cut (equpol (cpol (a,b) p) (cpol ((coef (cpol (a,b) p) t),t) vpol));
Intros.
Apply Tpol_Lex3_car; Auto.
Simpl.
Replace b0 with (hterm (cpol (a0,b0) p0)); Auto.
Replace b with (hterm (cpol (a,b) p)); Auto.

Replace (hterm (cpol (a0,b0) p0))
 with (hterm
        (suma_app (cpol (a,b) p)
          (pol_opp
            (mult_m f0
              ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
               (div_term t (hterm f0))))))); Auto.
Replace (hterm
          (suma_app (cpol (a,b) p)
            (pol_opp
              (mult_m f0
                ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
                 (div_term t (hterm f0)))))))
 with (hterm
        (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol)
          (pol_opp
            (mult_m f0
              ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
               (div_term t (hterm f0))))))); Auto.
Replace (hterm (cpol (a,b) p))
 with (hterm (cpol ((coef (cpol (a,b) p) t),t) vpol)); Auto.
Apply hterm_eq_suma_Ttm; Auto.
Apply eq_nvpol with (cpol (a0,b0) p0); Trivial.

Apply equpol_tran
 with (suma_app (cpol (a,b) p)
        (pol_opp
          (mult_m f0
            ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
             (div_term t (hterm f0)))))); Trivial.
Apply equpol_ss; Auto.

Apply eqQ_trans with (coef (cpol (a,b) p) t).
Apply full_hcoef; Auto.

Apply eqQ_trans
 with (hcoef
        (mult_m f0
          ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
           (div_term t (hterm f0))))).
Apply eqQ_trans
 with (multQ (hcoef f0)
        (mon_coef
          ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
           (div_term t (hterm f0))))).
Unfold mon_coef.
Apply eqQ_sym.
Apply eqQ_trans
 with (multQ (divQ (coef (cpol (a,b) p) t) (hcoef f0)) (hcoef f0)).
Auto.

Apply eqQ_trans
 with (divQ (multQ (coef (cpol (a,b) p) t) (hcoef f0)) (hcoef f0)).
Auto.

Apply eqQ_trans
 with (divQ (multQ (hcoef f0) (coef (cpol (a,b) p) t)) (hcoef f0));
Auto.

Apply eqQ_sym.
Apply hcoef_mult; Trivial.

Apply hcoef_pol_opp_term; Auto.

Transitivity t.
Apply full_hterm; Auto.

Symmetry; Auto.

Apply equpol_tran
 with (suma_app x (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol) x0));
Auto.
Apply equpol_tran
 with (suma_app vpol
        (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol) vpol)); Auto.


(* Subsubcaso (equpol x vpol) y ~(equpol x0 vpol) *)

Cut (equpol (cpol (a,b) p)
      (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol) x0)); Intros.
Cut (hterm (cpol (a,b) p))=t; Intros.
Cut (eqQ (hcoef (cpol (a,b) p))
      (hcoef (cpol ((coef (cpol (a,b) p) t),t) vpol))); Intros.
Cut (equpol (cpol (a0,b0) p0)
      (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol)
        (suma_app x0
          (pol_opp
            (mult_m f0
              ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
               (div_term t (hterm f0)))))))); Intros.
Cut (hterm (cpol (a,b) p))
     =(hterm (cpol ((coef (cpol (a,b) p) t),t) vpol)); Intros.
Apply Tpol_Lex3_car; Auto.
Simpl.
Replace b0 with (hterm (cpol (a0,b0) p0)); Auto.
Replace b with (hterm (cpol (a,b) p)); Auto.
Replace (hterm (cpol (a0,b0) p0))
 with (hterm
        (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol)
          (suma_app x0
            (pol_opp
              (mult_m f0
                ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
                 (div_term t (hterm f0)))))))); Auto.

Rewrite H46.
Apply hterm_eq_suma_Ttm; Auto.
Apply eq_nvpol with (cpol (a0,b0) p0); Trivial.

Apply eqQ_trans
 with (multQ_neg
        (hcoef
          (pol_opp
            (mult_m f0
              ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
               (div_term t (hterm f0))))))).
Apply eqQ_trans
 with (hcoef
        (mult_m f0
          ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
           (div_term t (hterm f0))))).
Apply eqQ_trans
 with (multQ (hcoef f0)
        (mon_coef
          ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
           (div_term t (hterm f0))))).
Unfold mon_coef.
Apply eqQ_trans with (coef (cpol (a,b) p) t); Auto.
Apply eqQ_sym.
Apply eqQ_trans
 with (multQ (divQ (coef (cpol (a,b) p) t) (hcoef f0)) (hcoef f0));
Auto.
Apply eqQ_trans
 with (divQ (multQ (coef (cpol (a,b) p) t) (hcoef f0)) (hcoef f0));
Auto.
Apply eqQ_trans
 with (divQ (multQ (hcoef f0) (coef (cpol (a,b) p) t)) (hcoef f0));
Auto.

Apply eqQ_sym.
Apply hcoef_mult; Trivial.

Apply hcoef_pol_opp_term; Auto.

Apply eq_mulQ_neg.
Apply eqQ_trans
 with (hcoef
        (suma_app
          (pol_opp
            (mult_m f0
              ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
               (div_term t (hterm f0))))) x0)); Auto.
Apply hcoef_suma_Ttm; Trivial.


Rewrite H26; Apply H32; Auto.


Symmetry.
Transitivity (hterm
               (suma_app
                 (pol_opp
                   (mult_m f0
                     ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
                      (div_term t (hterm f0))))) x0)); Auto.

Transitivity (hterm
               (pol_opp
                 (mult_m f0
                   ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
                    (div_term t (hterm f0)))))).
Apply hterm_suma_Ttm; Auto.

Rewrite H26; Apply H32; Auto.

Transitivity t; Trivial.
Symmetry; Auto.

Transitivity t; Trivial.
Symmetry; Apply full_hterm; Auto.

Apply equpol_tran
 with (suma_app (cpol (a,b) p)
        (pol_opp
          (mult_m f0
            ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
             (div_term t (hterm f0)))))); Auto.

Apply equpol_tran
 with (suma_app (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol) x0)
        (pol_opp
          (mult_m f0
            ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
             (div_term t (hterm f0)))))); Auto.


Apply eqQ_trans with (coef (cpol (a,b) p) (hterm (cpol (a,b) p))); Auto.
Apply eqQ_sym.
Apply eqQ_trans
 with (coef (cpol ((coef (cpol (a,b) p) t),t) vpol)
        (hterm (cpol ((coef (cpol (a,b) p) t),t) vpol))); Auto.

Rewrite H43.

Replace (hterm (cpol ((coef (cpol (a,b) p) t),t) vpol)) with t.
Simpl.
Elim (eq_tm_dec t t).
Intros.
Elim (eq_tm_dec t b); Intros; Auto.

Intro e; Elim e; Auto.

Symmetry; Auto.

Transitivity (hterm
               (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol) x0));
Auto.
Transitivity (hterm (cpol ((coef (cpol (a,b) p) t),t) vpol)); Auto.
Apply hterm_suma_Ttm; Auto.
Replace (hterm (cpol ((coef (cpol (a,b) p) t),t) vpol)) with t; Auto.
Symmetry.
Apply full_hterm; Auto.

Apply equpol_tran
 with (suma_app x (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol) x0));
Trivial.
Apply equpol_tran
 with (suma_app vpol
        (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol) x0)); Auto.

(Elim (vpol_dec_full_term x0); Trivial; Intros).

(* Caso x=/ vpol y x0=vpol  *)


Cut (equpol (cpol (a,b) p)
      (suma_app x (cpol ((coef (cpol (a,b) p) t),t) vpol))); Intros.
Cut b0=b; Intros.
Rewrite <- H43.
Apply Tpol_Lex3_cdr; Auto.
Apply H with f0; Auto.
Apply red1_simpl with t; Auto.
Apply aux1_red_menor2 with a b x; Auto.

Apply eq_cpol with (a,b).
Apply equpol_tran with (cpol (a0,b0) p0).
Apply eq_mon_cpol.
Rewrite H43.
Red.
Right.
Split; Auto.
Apply eqQ_trans with (hcoef (cpol (a,b) p)); Auto.
Apply eqQ_trans with (hcoef (cpol (a0,b0) p0)); Auto.

Apply eqQ_trans
 with (hcoef
        (suma_app (cpol (a,b) p)
          (pol_opp
            (mult_m f0
              ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
               (div_term t (hterm f0))))))); Auto.
Apply eqQ_sym.
Apply hcoef_suma_Ttm; Auto.
Rewrite H26.
Replace (hterm (cpol (a,b) p))
 with (hterm (suma_app x (cpol ((coef (cpol (a,b) p) t),t) vpol)));
Auto.
Replace (hterm (suma_app x (cpol ((coef (cpol (a,b) p) t),t) vpol)))
 with (hterm x); Auto.
Symmetry.
Apply hterm_suma_Ttm; Auto.
Replace (hterm (cpol ((coef (cpol (a,b) p) t),t) vpol)) with t; Auto.
Symmetry.
Apply term_monom_hterm; Auto.

Apply equpol_tran
 with (suma_app (cpol (a,b) p)
        (pol_opp
          (mult_m f0
            ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
             (div_term t (hterm f0)))))); Auto.
Apply equpol_tran
 with (cpol (a,b)
        (suma_app p
          (pol_opp
            (mult_m f0
              ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
               (div_term t (hterm f0))))))); Auto.

Apply equpol_cpol.
Apply monot_suma_l.
Apply opp_comp.
Apply mult_pm_comp_2.
Red.
Right.
Split; Auto.
Apply eg_denomQ; Auto.
Cut (term_in_pol p t); Intros.
Simpl.
Elim (eq_tm_dec t b); Intros; Auto.
Rewrite <- a4 in ff.
Cut (no_term_in_pol p t); Intros.
Red in H44.
Red in H45.
Elim H44; Auto.

Apply full_no_term with a; Auto.

Apply aux1_red_menor2 with a b x; Auto.

Transitivity (hterm (cpol (a,b) p)); Auto.
Transitivity (hterm (cpol (a0,b0) p0)).
Symmetry; Auto.

Transitivity (hterm
               (suma_app (cpol (a,b) p)
                 (pol_opp
                   (mult_m f0
                     ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
                      (div_term t (hterm f0))))))); Auto.
Apply hterm_suma_Ttm; Auto.
Rewrite H26.
Replace (hterm (cpol (a,b) p)) with b.
Apply H31.
Cut (term_in_pol p t); Intros.
Cut ~b=t; Intros.
Cut (term_in_pol (suma_app x (cpol ((coef (cpol (a,b) p) t),t) vpol)) b);
Intros.
Elim (term_in_sum x (cpol ((coef (cpol (a,b) p) t),t) vpol) b); Intros;
Auto.
Cut b=t; Intros.
Elim H44; Auto.

Apply eq_term_in_pol_monom with (coef (cpol (a,b) p) t); Auto.

Apply comp_term_in_pol with (cpol (a,b) p); Auto.
Replace b with (hterm (cpol (a,b) p)); Auto.
Replace (cpol (a,(hterm (cpol (a,b) p))) p) with (cpol (a,b) p); Auto.
Replace (hterm (cpol (a,b) p)) with b; Auto.
Symmetry; Auto.

Red; Intros.
Rewrite <- H44 in H43.
Cut (no_term_in_pol p b); Intros; Auto.
Apply full_no_term with a; Auto.

Apply aux1_red_menor2 with a b x; Auto.

Symmetry; Auto.

Apply equpol_tran
 with (suma_app x (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol) x0));
Auto.

Apply equpol_tran
 with (suma_app x
        (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol) vpol)); Auto.

(* falta el caso en que x y x0 son distintos de vpol*)

Cut b0=b; Intros.
Rewrite <- H42.
Apply Tpol_Lex3_cdr; Auto.
Apply H with f0; Auto.
Apply red1_simpl with t; Auto.
Apply aux2_red_menor2 with a b x x0; Auto.

Apply eq_cpol with (a,b).
Apply equpol_tran with (cpol (a0,b0) p0).
Apply eq_mon_cpol.
Rewrite H42.
Red.
Right.
Split; Auto.
Apply eqQ_trans with (hcoef (cpol (a,b) p)); Auto.
Apply eqQ_trans with (hcoef (cpol (a0,b0) p0)); Auto.
Apply eqQ_trans
 with (hcoef
        (suma_app (cpol (a,b) p)
          (pol_opp
            (mult_m f0
              ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
               (div_term t (hterm f0))))))); Auto.
Apply eqQ_sym.
Apply hcoef_suma_Ttm; Auto.
Rewrite H26.
Replace (hterm (cpol (a,b) p))
 with (hterm
        (suma_app x
          (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol) x0))); Auto.
Replace (hterm
          (suma_app x
            (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol) x0)))
 with (hterm x); Auto.
Symmetry.
Apply hterm_suma_Ttm; Auto.
Replace (hterm (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol) x0))
 with t; Auto.
Symmetry.
Transitivity (hterm (cpol ((coef (cpol (a,b) p) t),t) vpol)); Auto.
Apply hterm_suma_Ttm; Auto.
Replace (hterm (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol) x0))
 with t.
Replace (hterm (cpol ((coef (cpol (a,b) p) t),t) vpol)) with t; Auto.
Symmetry.
Apply term_monom_hterm; Auto.

Symmetry.
Transitivity (hterm (cpol ((coef (cpol (a,b) p) t),t) vpol)); Auto.
Apply hterm_suma_Ttm; Auto.
Replace (hterm (cpol ((coef (cpol (a,b) p) t),t) vpol)) with t; Auto.
Symmetry.
Apply term_monom_hterm; Auto.

Apply equpol_tran
 with (suma_app (cpol (a,b) p)
        (pol_opp
          (mult_m f0
            ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
             (div_term t (hterm f0)))))); Auto.
Apply equpol_tran
 with (cpol (a,b)
        (suma_app p
          (pol_opp
            (mult_m f0
              ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
               (div_term t (hterm f0))))))); Auto.

Apply equpol_cpol.
Apply monot_suma_l.
Apply opp_comp.
Apply mult_pm_comp_2.
Red.
Right.
Split; Auto.
Apply eg_denomQ; Auto.
Cut (term_in_pol p t); Intros.
Simpl.
Elim (eq_tm_dec t b); Intros; Auto.
Rewrite <- a3 in ff.
Cut (no_term_in_pol p t); Intros.
Red in H43.
Red in H44.
Elim H43; Auto.

Apply full_no_term with a; Auto.

Apply aux2_red_menor2 with a b x x0; Auto.

Transitivity (hterm (cpol (a,b) p)); Auto.
Transitivity (hterm (cpol (a0,b0) p0)); Auto.
Symmetry; Auto.

Transitivity (hterm
               (suma_app (cpol (a,b) p)
                 (pol_opp
                   (mult_m f0
                     ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
                      (div_term t (hterm f0))))))); Auto.
Apply hterm_suma_Ttm; Auto.
Rewrite H26.
Replace (hterm (cpol (a,b) p))
 with (hterm
        (suma_app x
          (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol) x0)));
Intros.
Replace (hterm
          (suma_app x
            (suma_app (cpol ((coef (cpol (a,b) p) t),t) vpol) x0)))
 with (hterm x); Intros.
Apply H31; Auto.

Symmetry.
Apply hterm_suma_Ttm; Auto.
Apply Ttm_suma_hterm; Auto.
Replace (hterm (cpol ((coef (cpol (a,b) p) t),t) vpol)) with t; Auto.
Symmetry.
Apply term_monom_hterm; Auto.

Apply Ttm_trans with t n; Auto.

Auto.

Auto.

Auto.

Apply no_eq_no_vpol_opp.
Apply contr_mult_nz_monom; Trivial.
Apply no_divQ_zero; Auto.

Auto.

Unfold z_monom.
Apply no_divQ_zero; Auto.

Auto.

Auto.

Auto.

Apply eqQ_trans
 with (multQ_neg
        (hcoef
          (pol_opp
            (pol_opp
              (mult_m f0
                ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
                 (div_term t (hterm f0)))))))).
Apply hcoef_pol_opp_term; Auto.

Apply eq_mulQ_neg.
Apply eqQ_trans
 with (hcoef
        (mult_m f0
          ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
           (div_term t (hterm f0))))).
Apply eqQ_trans
 with (multQ (hcoef f0)
        (mon_coef
          ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
           (div_term t (hterm f0))))).
Unfold mon_coef.
Apply eqQ_sym.
Apply eqQ_trans
 with (multQ (divQ (coef (cpol (a,b) p) t) (hcoef f0)) (hcoef f0));
Auto.
Apply eqQ_trans
 with (divQ (multQ (coef (cpol (a,b) p) t) (hcoef f0)) (hcoef f0));
Auto.
Apply eqQ_trans
 with (divQ (multQ (hcoef f0) (coef (cpol (a,b) p) t)) (hcoef f0));
Auto.

Apply eqQ_sym.
Apply hcoef_mult; Trivial.
Simpl; Auto.

Apply eq_hcoef; Auto.
Apply full_term_opp; Auto.

EAuto.

Apply full_coef with (cpol (a,b) p); Trivial.

Transitivity (hterm
               (mult_m f0
                 ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
                  (div_term t (hterm f0))))).
Symmetry.
Apply hterm_pol_opp_term.
Apply full_mult_m; Auto.
Apply term_div_full; Auto.
Apply full_coef with (cpol (a,b) p); Trivial.

Transitivity (term_mult (hterm f0)
               (mon_term
                 ((divQ (coef (cpol (a,b) p) t) (hcoef f0)),
                  (div_term t (hterm f0))))).
Apply hterm_mult_m; Trivial.
Simpl.
Apply term_div_full; Auto.
Apply full_coef with (cpol (a,b) p); Trivial.

Unfold z_monom.
Apply no_divQ_zero; Auto.

Simpl.
Symmetry.
Apply divis_im_divt with n; Trivial.
EAuto.

Apply full_coef with (cpol (a,b) p); Trivial.

Apply elim_red_exp with f0 (cpol (a,b) p).
Apply red1_exp_simpl
 with (div_term t (hterm f0)) (divQ (coef (cpol (a,b) p) t) (hcoef f0));
Trivial.

Apply term_div_full; Auto.
Apply full_coef with (cpol (a,b) p); Trivial.

Transitivity (term_mult (hterm f0) (div_term t (hterm f0))); Auto.
Apply divis_im_divt with n; Auto.
Apply full_coef with (cpol (a,b) p); Trivial.

Inversion fg; Auto.

Inversion H3; Auto.
Save.
 
Lemma buen_ord_red1: (F:(list pol_full))(noetheriano ? (inc_Red1 F)).

Red; Intros.
Apply wf_incl with Tpol_full.
Red; Intros.
Red in H.
Apply Red1_menor2 with F; Auto.

Apply Tpol_full_wf.
Save.

*)